Imports Microsoft.VisualBasic
Imports System.Drawing
Imports System.Text
Imports DSC.HSMSPC.HMI.BaseObject
'Imports System.Web.UI.Page

Namespace DSC.HSMSPC.HMI.Utility

    Public Enum LegendPos As Int16
        CenterTop
        CenterBot
        Custom
        Right
        Left
        RightTop
    End Enum

    Public Enum ToolLine As Int16
        HorrizontalCustom
        VerticalCustom
    End Enum

    Public Class TChartFunc

        Public Shared ColorList() As String = {"32CD32", "FF0000", "DEB887", "0000FF", "778899", _
                                               "7FFF00", "4B0082", "CD853F", "00BFFF", "F0E68C", _
                                               "FFA500", "20B2AA", "FF00FF", "000000", "FF6347", _
                                               "D9DC00", "73B7FF", "FA007A", "DC0300", "2523D7", "DC143C"}
        ''' <summary>
        ''' oUInt32榡ms
        ''' </summary>
        ''' <param name="ColorIndex">0~12ms</param>
        ''' <returns>mUInt32s</returns>
        Public Shared Function GetUIntColor(ByVal ColorIndex As Int16) As UInt32
            Dim HexColor As String = ColorList(ColorIndex)
            Return RGB(Convert.ToInt32(HexColor.Substring(0, 2), 16), Convert.ToInt32(HexColor.Substring(2, 2), 16), Convert.ToInt32(HexColor.Substring(4, 2), 16))
        End Function

        Public Shared Sub SetChartHeight(ByVal paramPage As Page, ByVal paramTChart As TeeChart.TChart(), ByVal paramChartName As String(), ByRef paramScript As String)
            For i As Int16 = 0 To paramTChart.Length - 1
                paramScript += "document.all(""" + paramChartName(i) + """).style.height=" + paramTChart(i).Height.ToString + ";" + vbCrLf
            Next
        End Sub

        ''' <summary>
        ''' ]wLegendm
        ''' </summary>
        ''' <param name="paramChart">chart</param>
        ''' <param name="paramPosition">m</param>
        Public Shared Sub SetLegendPosition(ByRef paramChart As TeeChart.TChartClass, ByVal paramPosition As LegendPos, Optional ByVal paramLeftPx As Integer = -1)
            If paramPosition = LegendPos.Custom AndAlso paramLeftPx <> -1 Then
                paramChart.Legend.CustomPosition = True
                paramChart.Legend.Alignment = TeeChart.ELegendAlignment.laTop
                paramChart.Legend.PositionUnits = TeeChart.EPositionUnits.puPixels
                paramChart.Legend.Left = paramLeftPx
            Else
                paramChart.Legend.CustomPosition = False
                Select Case paramPosition
                    Case LegendPos.CenterTop
                        paramChart.Legend.Alignment = TeeChart.ELegendAlignment.laTop
                    Case LegendPos.CenterBot
                        paramChart.Legend.Alignment = TeeChart.ELegendAlignment.laBottom
                    Case LegendPos.Right
                        paramChart.Legend.Alignment = TeeChart.ELegendAlignment.laRight
                    Case LegendPos.Left
                        paramChart.Legend.Alignment = TeeChart.ELegendAlignment.laLeft
                    Case LegendPos.RightTop
                        paramChart.Legend.CustomPosition = True
                        paramChart.Legend.Alignment = TeeChart.ELegendAlignment.laTop
                        paramChart.Legend.PositionUnits = TeeChart.EPositionUnits.puPixels
                End Select
            End If
        End Sub

        'pLegende
        Public Shared Function CalcLegendWidth(ByVal paramChart As TeeChart.TChartClass, ByVal paramChartWidth As Integer) As Integer
            Dim Offset As Integer
            Dim LegendTxt As String = ""
            Dim JPG As New System.Drawing.Bitmap(500, 500)
            Dim G As System.Drawing.Graphics = System.Drawing.Graphics.FromImage(JPG)
            Dim WordsWidth As Single
            Dim LegendFont As New System.Drawing.Font(paramChart.Legend.Font.Name, paramChart.Legend.Font.Size)
            Dim SpaceNum As Integer = 0
            Dim LongestLegendLength As Integer = 0

            If paramChart.Legend.CheckBoxes = True Then
                Offset = 46
            Else
                Offset = 36
            End If

            For cnt As Integer = 0 To paramChart.SeriesCount - 1
                If paramChart.Series(cnt).ShowInLegend Then
                    LongestLegendLength = Math.Max(LongestLegendLength, paramChart.Series(cnt).Title.Length)
                    SpaceNum += 1
                End If
            Next

            WordsWidth = G.MeasureString("W".PadLeft(LongestLegendLength * SpaceNum, "W"), LegendFont).Width()
            CalcLegendWidth = WordsWidth + Offset * SpaceNum

            G.Dispose()
            JPG.Dispose()
            LegendFont.Dispose()
        End Function

        ''' <summary>
        ''' Chart, ó]wl
        ''' </summary>
        ''' <param name="TChart">ؼChart</param>
        ''' <param name="Header">]wHeaderr</param>
        ''' <remarks></remarks>
        Public Shared Sub SetBaseChart(ByRef TChart As TeeChart.TChart, ByVal Header As String, Optional ByVal Is3D As Boolean = False)
            TChart = New TeeChart.TChart
            TChart.Aspect.View3D = Is3D                                    ']wO_3D
            TChart.Walls.Visible = False                                    ']wO_u
            TChart.Walls.Back.Visible = False
            TChart.Walls.Bottom.Visible = False
            TChart.Walls.Left.Visible = False
            TChart.Walls.Right.Visible = False
            TChart.Panel.Color = VBColor(Color.White)                       ']wO_u
            TChart.Panel.Border.Visible = True
            TChart.Panel.Border.Width = 1
            TChart.Panel.Border.Color = VBColor(Color.Black)
            TChart.Panel.Gradient.StartColor = VBColor(Color.Beige)
            TChart.Panel.Gradient.EndColor = VBColor(Color.White)
            TChart.Panel.Gradient.Direction = TeeChart.EGradientDirection.gdBottomTop
            TChart.Axis.Right.Visible = False                               ']wkbu
            TChart.Axis.Top.Visible = False                                 ']wݶbu
            TChart.Header.Visible = True
            TChart.Header.Text.Clear()
            TChart.Header.Text.Add(Header)                                  ']wHeaderr
            TChart.Header.Font.Size = 12
            TChart.Header.Font.Color = VBColor(Color.Blue)
            TChart.Footer.Visible = True
            TChart.Footer.Font.Size = 10
            TChart.Footer.Font.Color = VBColor(Color.Purple)
            TChart.Footer.Font.Italic = False
            TChart.Legend.Visible = True
            TChart.Legend.LegendStyle = TeeChart.ELegendStyle.lsSeries      ']wϨһܼƦCTitle
            TChart.Legend.ShadowSize = 1
            TChart.Legend.ResizeChart = True
            TChart.Legend.FontSeriesColor = True
            TChart.Legend.Symbol.WidthUnits = TeeChart.ELegendSymbolSize.lcsPixels
            TChart.Legend.Symbol.Width = 7
            TChart.Legend.Font.Name = "Courier New"
            TChart.Legend.Font.Size = 9
            TChart.Export.asXLS.IncludeHeader = True
            TChart.Export.asXLS.IncludeIndex = True
            TChart.Export.asXLS.IncludeLabels = True
            TChart.Environment.IEPrintWithPage = True
            TChart.Printer.MarginTop = 0
            TChart.Printer.MarginBottom = 0
            TChart.Printer.MarginLeft = 0
            TChart.Printer.MarginRight = 0
        End Sub

        ''' <summary>
        ''' ]wChartGridO_
        ''' </summary>
        ''' <param name="TChart">ؼChart</param>
        ''' <param name="Show">O_</param>
        ''' <remarks></remarks>
        Public Shared Sub ChartGrid(ByRef TChart As TeeChart.TChart(), ByVal Show As Boolean)
            Dim cnt As Integer
            For cnt = 0 To TChart.Length - 1
                TChart(cnt).Axis.Left.GridPen.Visible = Show
                TChart(cnt).Axis.Right.GridPen.Visible = Show
                TChart(cnt).Axis.Bottom.GridPen.Visible = Show
            Next
        End Sub

        ''' <summary>
        ''' ]wyжb
        ''' </summary>
        ''' <param name="TAxis">ؼЮyжb</param>
        ''' <param name="AutoScale">O_۰ʽվ</param>
        ''' <param name="UpperLimit">W</param>
        ''' <param name="LowerLimit">U</param>
        ''' <param name="MasterScale">DׯŶZ</param>
        ''' <param name="SlaveScale">I</param>
        ''' <param name="RelativePosition">bu첾ʤ</param>
        ''' <param name="Offset">׸v</param>
        ''' <param name="GridPen">O_ܮyЮu</param>
        ''' <param name="AxisLabelStyle">yܮ榡</param>
        ''' <remarks></remarks>
        Public Shared Sub SetAxis(ByVal TAxis As TeeChart.IAxis, ByVal AutoScale As Boolean, _
                                  ByVal UpperLimit As Double, ByVal LowerLimit As Double, _
                                  ByVal MasterScale As Double, ByVal SlaveScale As Double, _
                                  ByVal RelativePosition As Double, ByVal Offset As Single, _
                                  Optional ByVal GridPen As Boolean = True, Optional ByVal AxisLabelStyle As TeeChart.EAxisLabelStyle = TeeChart.EAxisLabelStyle.talAuto)

            Dim cup As Double
            If UpperLimit < LowerLimit Then
                cup = UpperLimit
                UpperLimit = LowerLimit
                LowerLimit = cup
            End If
            TAxis.Automatic = AutoScale                     'צ۰ʽվ
            If UpperLimit < TAxis.Minimum Then
                TAxis.Minimum = LowerLimit                      'bU
                TAxis.Maximum = UpperLimit                      'bW
            Else
                TAxis.Maximum = UpperLimit                      'bW
                TAxis.Minimum = LowerLimit                      'bU
            End If
            TAxis.Increment = MasterScale                   'DׯŶZ
            TAxis.MinorTickCount = SlaveScale               'I
            TAxis.PositionPercent = RelativePosition        'bu첾ʤ
            TAxis.AxisPen.Width = 2                         ']wbue
            TAxis.GridPen.Visible = GridPen                 'ܮu
            TAxis.MinimumOffset = Offset
            TAxis.MaximumOffset = Offset
            TAxis.Labels.Style = AxisLabelStyle
            TAxis.Visible = True
        End Sub

        ''' <summary>
        ''' ]wyжb
        ''' </summary>
        ''' <param name="TAxis">ؼЮyжb</param>
        ''' <param name="AutoScale">O_۰ʽվ</param>
        ''' <param name="UpperLimit">W</param>
        ''' <param name="LowerLimit">U</param>
        ''' <param name="MasterScale">DׯŶZ</param>
        ''' <param name="SlaveScale">I</param>
        ''' <param name="RelativePosition">bu첾ʤ</param>
        ''' <param name="Offset">׸v</param>
        ''' <param name="AxisColor">yC</param>
        ''' <param name="GridPen">O_ܮyЮu</param>
        ''' <remarks></remarks>
        Public Shared Sub SetAxis(ByVal TAxis As TeeChart.IAxis, ByVal AutoScale As Boolean, ByVal UpperLimit As Double, ByVal LowerLimit As Double, ByVal MasterScale As Double, ByVal SlaveScale As Double, ByVal RelativePosition As Double, ByVal Offset As Single, ByVal AxisColor As Color, Optional ByVal GridPen As Boolean = True)
            SetAxis(TAxis, AutoScale, UpperLimit, LowerLimit, MasterScale, SlaveScale, RelativePosition, Offset)
            TAxis.Title.Font.Color = VBColor(AxisColor)
            TAxis.Labels.Font.Color = VBColor(AxisColor)
        End Sub

        'Public Shared Sub AddChartData(ByVal chartSeries As TeeChart.ISeries, ByVal dataRow As DataRow)
        '    For i As Int16 = 0 To dataRow.ItemArray.Count - 1
        '        chartSeries.Add(
        '    Next
        'End Sub

        ''' <summary>
        ''' sWƦC
        ''' </summary>
        ''' <param name="TChart">ؼChart</param>
        ''' <param name="SeriesType">sWƦC</param>
        ''' <param name="Title">ƦCtitle</param>
        ''' <param name="_color">ƦCC</param>
        ''' <param name="ShowInLegend">ƦCO_ܹϨ</param>
        ''' <param name="paramVerticalAxis">yжb</param>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Shared Function AddSeries(ByVal TChart As TeeChart.TChartClass, ByVal SeriesType As TeeChart.ESeriesClass, _
                                         ByVal Title As String, ByVal _color As Color, _
                                         Optional ByVal paramVerticalAxis As TeeChart.EVerticalAxis = TeeChart.EVerticalAxis.aLeftAxis, _
                                         Optional ByVal ShowInLegend As Boolean = True) As Integer

            'sWó]wƦCݩ(Ǧ^ƦCs)
            Dim SeriesNum As Integer
            SeriesNum = TChart.AddSeries(SeriesType)               'sWƦC
            TChart.Series(SeriesNum).Title = Title                 ']wƦCW
            TChart.Series(SeriesNum).Pen.Width = 2                ']wue
            TChart.Series(SeriesNum).Color = VBColor(_color)                ']wC
            TChart.Series(SeriesNum).Marks.Visible = False         ']wƦCƭܻP_
            TChart.Series(SeriesNum).ShowInLegend = ShowInLegend   ']wƦCO_ܹϨ(Sγ~)
            TChart.Series(SeriesNum).VerticalAxis = paramVerticalAxis
            Return SeriesNum
        End Function

        ''' <summary>
        ''' sWƦC
        ''' </summary>
        ''' <param name="TChart">ؼChart</param>
        ''' <param name="SeriesType">sWƦC</param>
        ''' <param name="Title">ƦCtitle</param>
        ''' <param name="ShowInLegend">ƦCO_ܹϨ</param>
        ''' <param name="paramVerticalAxis">yжb</param>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Shared Function AddSeries(ByVal TChart As TeeChart.TChartClass, _
                                         ByVal SeriesType As TeeChart.ESeriesClass, _
                                         ByVal Title As String, _
                                         Optional ByVal paramVerticalAxis As TeeChart.EVerticalAxis = TeeChart.EVerticalAxis.aLeftAxis, _
                                         Optional ByVal ShowInLegend As Boolean = True) As Integer

            'sWó]wƦCݩ(Ǧ^ƦCs)
            Dim SeriesNum As Integer
            SeriesNum = TChart.AddSeries(SeriesType)                 'sWƦC
            TChart.Series(SeriesNum).Title = Title                   ']wƦCW
            TChart.Series(SeriesNum).Pen.Width = 2                   ']wue
            TChart.Series(SeriesNum).Color = GetUIntColor(SeriesNum) ']wC
            TChart.Series(SeriesNum).Marks.Visible = False           ']wƦCƭܻP_
            TChart.Series(SeriesNum).ShowInLegend = ShowInLegend     ']wƦCO_ܹϨ(Sγ~)
            TChart.Series(SeriesNum).VerticalAxis = paramVerticalAxis
            Return SeriesNum
        End Function

        ''' <summary>
        ''' sWƦC
        ''' </summary>
        ''' <param name="TChart">ؼChart</param>
        ''' <param name="SeriesType">sWƦC</param>
        ''' <param name="Titles">ƦCtitle</param>
        ''' <param name="ShowInLegend">ƦCO_ܹϨ</param>
        ''' <remarks></remarks>
        Public Shared Sub AddSeries(ByVal TChart As TeeChart.TChartClass, ByVal SeriesType As TeeChart.ESeriesClass, _
                                    ByVal Titles As String(), Optional ByVal ShowInLegend As Boolean = True)

            'sWó]wƦCݩ(Ǧ^ƦCs)
            For i As Int16 = 0 To Titles.Length - 1
                TChart.AddSeries(SeriesType)               'sWƦC
                TChart.Series(i).Title = Titles(i)
                TChart.Series(i).Pen.Width = 1
                TChart.Series(i).Color = GetUIntColor(i)
                TChart.Series(i).Marks.Visible = False         ']wƦCƭܻP_
                TChart.Series(i).ShowInLegend = ShowInLegend   ']wƦCO_ܹϨ(Sγ~)
            Next

        End Sub

        Public Shared Sub AddSeriesXY(ByVal ChartSeries As TeeChart.ISeries, ByVal X As Integer, ByVal Y As Double, ByVal XLable As String)
            ChartSeries.AddXY(X, Y, XLable, ChartSeries.Color)
        End Sub

        Public Shared Sub AddSeriesNullXY(ByVal ChartSeries As TeeChart.ISeries, ByVal X As Integer, ByVal XLable As String)
            ChartSeries.AddNullXY(X, 0, XLable)
        End Sub

        ''' <summary>
        ''' sWCursoru
        ''' </summary>
        ''' <param name="TChart">ؼChart</param>
        ''' <param name="CursorDirection">Cursor Style</param>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Shared Function AddToolCursor(ByVal TChart As TeeChart.TChartClass, ByVal CursorDirection As TeeChart.ECursorToolStyle) As Integer
            'sWó]wCФu㪺ݩ(Ǧ^us)
            Dim ToolNum As Integer
            ToolNum = TChart.Tools.Add(TeeChart.EToolClass.tcCursor)                                    'sWCФu
            TChart.Tools.Items(ToolNum).asTeeCursor.Style = CursorDirection                             ']wCк( )
            TChart.Tools.Items(ToolNum).asTeeCursor.FollowMouse = True                                  ']wCHƹ
            TChart.Tools.Items(ToolNum).asTeeCursor.Snap = True
            TChart.Tools.Items(ToolNum).asTeeCursor.Pen.Style = TeeChart.EChartPenStyle.psSolid         ']wCнu
            TChart.Tools.Items(ToolNum).asTeeCursor.Pen.Color = VBColor(Color.Purple)                   ']wCнuC
            Return ToolNum
        End Function

        ''' <summary>
        ''' sWtu
        ''' </summary>
        ''' <param name="TChart">ؼChart</param>
        ''' <param name="TAxis">tuy</param>
        ''' <param name="Style">tuStyle</param>
        ''' <param name="Width">tue</param>
        ''' <param name="_color">tuC</param>
        ''' <param name="Value">tu</param>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Shared Function AddToolLine(ByVal TChart As TeeChart.TChartClass, ByVal TAxis As ToolLine, ByVal Style As Drawing.Drawing2D.DashStyle, ByVal Width As Integer, ByVal _color As Color, ByVal Value As Double) As Integer
            'sWó]wuu㪺ݩ(Ǧ^us)
            Dim ToolNum, LineNo, cnt As Integer
            '        Dim TName() As String
            ToolNum = TChart.AddSeries(TeeChart.ESeriesClass.scLine)             'sWƦC
            TChart.Series(ToolNum).VerticalAxis = TAxis
            TChart.Series(ToolNum).Pen.Style = Style
            TChart.Series(ToolNum).Color = VBColor(_color)
            TChart.Series(ToolNum).Pen.Width = Width
            TChart.Series(ToolNum).ShowInLegend = False
            If TAxis = ToolLine.VerticalCustom Then
                TChart.Series(ToolNum).AddXY(Value, 0, "", TChart.Series(cnt).Color)
            Else
                TChart.Series(ToolNum).AddXY(0, Value, "", TChart.Series(cnt).Color)
            End If
            LineNo = 0
            For cnt = 0 To ToolNum
                If Not (TChart.Series(cnt).Title Is Nothing) Then
                    If (TChart.Series(cnt).Title.IndexOf(":") > 0) Then
                        If (TChart.Series(cnt).Title.Split(":")(0) = "TOOLLINE") Then
                            LineNo += 1
                        End If
                    End If
                End If
            Next
            TChart.Series(ToolNum).Title = "TOOLLINE:" + LineNo.ToString.Trim
            If TAxis = ToolLine.VerticalCustom Then
                TChart.Series(ToolNum).Name = "VTOOLLINE_" + LineNo.ToString.Trim
            Else
                TChart.Series(ToolNum).Name = "HTOOLLINE_" + LineNo.ToString.Trim
            End If
            Return LineNo
        End Function

        ''' <summary>
        ''' ]wtu
        ''' </summary>
        ''' <param name="TChart">ؼChart</param>
        ''' <param name="LineNo">us</param>
        ''' <param name="Value">tu</param>
        ''' <remarks></remarks>
        Public Shared Sub SetToolLine(ByVal TChart As TeeChart.TChartClass, ByVal LineNo As Integer, ByVal Value As Double)
            'sWó]wuu㪺ݩ(Ǧ^us)
            Dim ToolNum, cnt As Integer
            Dim LineName() As String
            ToolNum = -1
            For cnt = 0 To TChart.SeriesCount - 1
                If Not (TChart.Series(cnt).Title Is Nothing) Then
                    If (TChart.Series(cnt).Title.IndexOf(":") > 0) Then
                        LineName = TChart.Series(cnt).Title.Split(":")
                        If (LineName(0) = "TOOLLINE") Then
                            If (Val(LineName(1)) = LineNo) Then
                                ToolNum = cnt
                                Exit For
                            End If
                        End If
                    End If
                End If
            Next
            TChart.Series(ToolNum).Delete(0)
            If TChart.Series(ToolNum).Name.Substring(0, 9) = "VTOOLLINE" Then
                TChart.Series(ToolNum).AddXY(Value, 0, "", TChart.Series(cnt).Color)
            Else
                TChart.Series(ToolNum).AddXY(0, Value, "", TChart.Series(cnt).Color)
            End If
        End Sub

        ''' <summary>
        ''' sWѤu
        ''' </summary>
        ''' <param name="TChart">ؼChart</param>
        ''' <param name="TopPos">yTop</param>
        ''' <param name="LeftPos">yLeft</param>
        ''' <param name="FontSize">rjp</param>
        ''' <param name="BackColor">IC</param>
        ''' <param name="FontColor">rC</param>
        ''' <param name="ShowFrame">O_ܵѤu</param>
        ''' <param name="IsVisible">O_ҰʵѤu</param>
        ''' <param name="shadowsize">vjp</param>
        ''' <param name="text">Ѥe</param>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Shared Function AddToolAnnotation(ByVal TChart As TeeChart.TChartClass, ByVal TopPos As Integer, ByVal LeftPos As Integer, ByVal FontSize As Integer, ByVal BackColor As Object, ByVal FontColor As Object, Optional ByVal ShowFrame As Boolean = True, Optional ByVal IsVisible As Boolean = True, Optional ByVal shadowsize As Integer = 1, Optional ByVal text As String = "") As Integer
            'sWó]wuu㪺ݩ(Ǧ^us)
            Dim ToolNum As Integer
            Dim _BackColor, _FontColor As System.UInt32
            If FontColor.GetType.ToString.Trim.ToUpper = "SYSTEM.UINT32" Then
                _FontColor = FontColor
            Else
                _FontColor = VBColor(FontColor)
            End If
            If BackColor.GetType.ToString.Trim.ToUpper = "SYSTEM.UINT32" Then
                _BackColor = BackColor
            Else
                _BackColor = VBColor(BackColor)
            End If
            ToolNum = TChart.Tools.Add(TeeChart.EToolClass.tcAnnotate)
            TChart.Tools.Items(ToolNum).asAnnotation.TextAlignment = TeeChart.ETextAlignment.aCenter
            TChart.Tools.Items(ToolNum).asAnnotation.Shape.CustomPosition = True
            TChart.Tools.Items(ToolNum).asAnnotation.Shape.Top = TopPos
            TChart.Tools.Items(ToolNum).asAnnotation.Shape.Left = LeftPos
            TChart.Tools.Items(ToolNum).asAnnotation.Shape.Color = _BackColor
            TChart.Tools.Items(ToolNum).asAnnotation.Shape.Font.Size = FontSize
            TChart.Tools.Items(ToolNum).asAnnotation.Shape.ShadowSize = shadowsize
            TChart.Tools.Items(ToolNum).asAnnotation.Shape.Font.Color = _FontColor
            TChart.Tools.Items(ToolNum).asAnnotation.Shape.ShapeStyle = TeeChart.EChartObjectShapeStyle.fosRectangle
            'TChart.Tools.Items(ToolNum).asAnnotation.Shape.Frame.Visible = ShowFrame
            TChart.Tools.Items(ToolNum).asAnnotation.AutoSize = True
            'TChart.Tools.Items(ToolNum).asAnnotation.Width = 200
            'TChart.Tools.Items(ToolNum).asAnnotation.Height = 30
            TChart.Tools.Items(ToolNum).asAnnotation.Text = text
            TChart.Tools.Items(ToolNum).Active = IsVisible
            Return ToolNum
        End Function

        ''' <summary>
        ''' ]wCursorbWܪXYƾ
        ''' </summary>
        ''' <param name="TChart">ؼChart</param>
        ''' <param name="TopPos">rYy</param>
        ''' <param name="LeftPos">rXy</param>
        ''' <param name="FontSize">rjp</param>
        ''' <param name="XValSize">XȦrjp</param>
        ''' <param name="Offset">v</param>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Shared Function SetCurMoveDataPara(ByVal TChart As TeeChart.TChartClass, ByVal TopPos As Integer, ByVal LeftPos As Integer, ByVal FontSize As Integer, ByVal XValSize As Integer, ByVal Offset As Integer) As Integer
            Dim ToolNum As Integer
            Dim backColor As Color = Color.LightYellow
            Dim LabelColor As Color = Color.LightBlue
            Dim cnt, tcnt As Integer
            Dim firstflag As Boolean = True
            Dim ShowLabelflag As Boolean = False
            ToolNum = AddToolAnnotation(TChart, TopPos, LeftPos, FontSize, backColor, Color.Purple)
            tcnt = 0
            For cnt = 0 To TChart.SeriesCount - 1
                If TChart.Series(cnt).ShowInLegend = True Then
                    ToolNum = AddToolAnnotation(TChart, TopPos, LeftPos + XValSize + tcnt * Offset, FontSize, backColor, TChart.Series(cnt).Color)
                    tcnt += 1
                    If firstflag Then
                        SetCurMoveDataPara = ToolNum
                        firstflag = False
                    End If
                Else
                    If Not (TChart.Series(cnt).Title Is Nothing) Then
                        If TChart.Series(cnt).Title.ToUpper = "XLABEL" Then
                            ShowLabelflag = True
                        End If
                    End If
                End If
            Next
            If ShowLabelflag Then
                ToolNum = AddToolAnnotation(TChart, TopPos, LeftPos + XValSize + tcnt * Offset, FontSize, LabelColor, Color.Black)
                TChart.Tools.Items(ToolNum).asAnnotation.Text = "XLABEL"
            End If
        End Function

        ''' <summary>
        ''' ]wChartA
        ''' </summary>
        ''' <param name="_page">Page</param>
        ''' <param name="WinChart">ؼChart</param>
        ''' <remarks></remarks>
        Private Shared Sub SetChartStatus(ByVal _page As System.Web.UI.Page, ByVal WinChart As TeeChart.TChart())
            Dim _fcontrol, _control, _divResultArea As New System.Web.UI.Control
            Try
                Dim ChartStatus As Boolean = False

                For Each _fcontrol In _page.Controls



                    If (_fcontrol.GetType.ToString.Trim = "System.Web.UI.HtmlControls.HtmlForm") Then
                        _divResultArea = _fcontrol.FindControl("DivResultArea")
                        If _divResultArea IsNot Nothing Then
                            _fcontrol = _divResultArea
                        End If
                        For Each _control In _fcontrol.Controls
                            If _control.GetType.ToString.Trim = "ASP.usercontrols_ucteecharttoolbar_ascx" Then
                                For Each _subcontrol As System.Web.UI.Control In _control.Controls
                                    If (_subcontrol.GetType.ToString.Trim = "System.Web.UI.HtmlControls.HtmlInputHidden") Then
                                        If CType(_subcontrol, HtmlInputHidden).Attributes.Item("title").Trim.ToUpper = "CHARTSTATUS" Then

                                            If CType(_subcontrol, HtmlInputHidden).Value.Trim.Length = 0 Then
                                                Exit Sub
                                            End If
                                            Dim Status() As String
                                            Dim cnt, SNo As Integer
                                            Status = Split(CType(_subcontrol, HtmlInputHidden).Value, ";")
                                            For cnt = 0 To Status.Length - 1
                                                For SNo = 0 To Status(cnt).Length - 1
                                                    WinChart(cnt).Series(SNo).Active = IIf(Status(cnt).Substring(SNo, 1) = "T", True, False)
                                                Next
                                            Next
                                            Exit For
                                        End If
                                    End If
                                Next
                            End If


                        Next
                        If ChartStatus = True Then
                            Exit For
                        End If
                    End If
                Next


            Catch ex As Exception

            End Try
        End Sub


        Private Shared Sub SetTooLLineLimit(ByVal TChart As TeeChart.TChartClass)
            ']wФuw쪺ƦCs(P_Xȳ̤jƦC,NƦCs]wФu)
            Dim cnt As Integer
            Dim MinValue(2), MaxValue(2), Value, offset As Double
            Dim fline() As Boolean = {True, True, True}
            If TChart.Axis.Bottom.Automatic = False Then
                MinValue(0) = TChart.Axis.Bottom.Minimum
                MaxValue(0) = TChart.Axis.Bottom.Maximum
                fline(0) = False
            End If
            If TChart.Axis.Left.Automatic = False Then
                MinValue(1) = TChart.Axis.Left.Minimum
                MaxValue(1) = TChart.Axis.Left.Maximum
                fline(1) = False
            End If
            If TChart.Axis.Right.Automatic = False Then
                MinValue(2) = TChart.Axis.Right.Minimum
                MaxValue(2) = TChart.Axis.Right.Maximum
                fline(2) = False
            End If
            For cnt = 0 To TChart.SeriesCount - 1
                If TChart.Series(cnt).ShowInLegend = True Then
                    If TChart.Series(cnt).ValueLists.Count > 0 Then
                        If (fline(0) = True) Then
                            MinValue(0) = TChart.Series(cnt).XValues.Minimum
                            MaxValue(0) = TChart.Series(cnt).XValues.Maximum
                            fline(0) = False
                        Else
                            If (TChart.Series(cnt).XValues.Minimum < MinValue(0)) Then
                                MinValue(0) = TChart.Series(cnt).XValues.Minimum
                            End If
                            If (TChart.Series(cnt).XValues.Maximum > MaxValue(0)) Then
                                MaxValue(0) = TChart.Series(cnt).XValues.Maximum
                            End If
                        End If
                        If (TChart.Series(cnt).VerticalAxis = TeeChart.EVerticalAxis.aLeftAxis) Then
                            If (fline(1) = True) Then
                                MinValue(1) = TChart.Series(cnt).YValues.Minimum
                                MaxValue(1) = TChart.Series(cnt).YValues.Maximum
                                fline(1) = False
                            Else
                                If (TChart.Series(cnt).YValues.Minimum < MinValue(1)) Then
                                    MinValue(1) = TChart.Series(cnt).YValues.Minimum
                                End If
                                If (TChart.Series(cnt).YValues.Maximum > MaxValue(1)) Then
                                    MaxValue(1) = TChart.Series(cnt).YValues.Maximum
                                End If
                            End If
                        End If
                        If (TChart.Series(cnt).VerticalAxis = TeeChart.EVerticalAxis.aRightAxis) Then
                            If (fline(2) = True) Then
                                MinValue(2) = TChart.Series(cnt).YValues.Minimum
                                MaxValue(2) = TChart.Series(cnt).YValues.Maximum
                                fline(2) = False
                            Else
                                If (TChart.Series(cnt).YValues.Minimum < MinValue(2)) Then
                                    MinValue(2) = TChart.Series(cnt).YValues.Minimum
                                End If
                                If (TChart.Series(cnt).YValues.Maximum > MaxValue(2)) Then
                                    MaxValue(2) = TChart.Series(cnt).YValues.Maximum
                                End If
                            End If
                        End If
                    End If
                End If
            Next
            offset = 0
            For cnt = 0 To TChart.SeriesCount - 1
                If TChart.Series(cnt).ShowInLegend = False Then
                    If Not (TChart.Series(cnt).Title Is Nothing) Then
                        If (TChart.Series(cnt).Title.IndexOf(":") > 0) Then
                            If (TChart.Series(cnt).Title.Split(":")(0) = "TOOLLINE") Then
                                If TChart.Series(cnt).Name.Substring(0, 10) = "HTOOLLINE_" Then
                                    Value = TChart.Series(cnt).YValues.Value(0)
                                    TChart.Series(cnt).Delete(0)
                                    'offset = (MaxValue(0) - MinValue(0)) / 10
                                    TChart.Series(cnt).AddXY(MinValue(0) - offset, Value, "", TChart.Series(cnt).Color)
                                    TChart.Series(cnt).AddXY(MaxValue(0) + offset, Value, "", TChart.Series(cnt).Color)
                                ElseIf TChart.Series(cnt).Name.Substring(0, 10) = "VTOOLLINE_" Then
                                    Value = TChart.Series(cnt).XValues.Value(0)
                                    TChart.Series(cnt).Delete(0)
                                    If (TChart.Series(cnt).VerticalAxis = TeeChart.EVerticalAxis.aLeftAxis) Then
                                        'offset = (MaxValue(1) - MinValue(1)) / 10
                                        TChart.Series(cnt).AddXY(Value, MinValue(1) - offset, "", TChart.Series(cnt).Color)
                                        TChart.Series(cnt).AddXY(Value, MaxValue(1) + offset, "", TChart.Series(cnt).Color)
                                    Else
                                        'offset = (MaxValue(2) - MinValue(2)) / 10
                                        TChart.Series(cnt).AddXY(Value, MinValue(2) - offset, "", TChart.Series(cnt).Color)
                                        TChart.Series(cnt).AddXY(Value, MaxValue(2) + offset, "", TChart.Series(cnt).Color)
                                    End If
                                End If
                            End If
                        End If
                    End If
                End If
            Next
        End Sub

        Private Shared Function SetCursorSeries(ByVal TChart As TeeChart.TChartClass) As Integer
            ']wФuw쪺ƦCs(P_Xȳ̤jƦC,NƦCs]wФu)
            'HX̤jиHseries
            Dim cnt, MaxXValue As Double
            Dim first As Boolean = True
            SetCursorSeries = -1
            For cnt = 0 To TChart.SeriesCount - 1
                If (TChart.Series(cnt).ShowInLegend = True) Then
                    If (first) Then
                        SetCursorSeries = cnt
                    End If
                    If (TChart.Series(cnt).Active = True) Then
                        If (first) Then
                            MaxXValue = TChart.Series(cnt).XValues.Maximum
                            SetCursorSeries = cnt
                            first = False
                        End If
                        If TChart.Series(cnt).XValues.Maximum > MaxXValue Then
                            MaxXValue = TChart.Series(cnt).XValues.Maximum
                            SetCursorSeries = cnt
                        End If
                    End If
                Else
                    If Not (TChart.Series(cnt).Title Is Nothing) Then
                        If TChart.Series(cnt).Title.Trim.ToUpper = "XLABEL" Then
                            SetCursorSeries = cnt
                            Exit For
                        End If
                        If TChart.Series(cnt).Title.Trim.ToUpper = "CURSOREVENT" Then
                            SetCursorSeries = cnt
                            Exit For
                        End If
                    End If
                End If
            Next
            'ª,HXIƳ̦hиHseries
            'Dim cnt, MaxCount As Single
            'Dim first As Boolean = True
            'SetCursorSeries = -1
            'For cnt = 0 To TChart.SeriesCount - 1
            '    If (TChart.Series(cnt).ShowInLegend = True) Then
            '        If (first) Then
            '            SetCursorSeries = cnt
            '        End If
            '        If (TChart.Series(cnt).Active = True) Then
            '            If (first) Then
            '                MaxCount = TChart.Series(cnt).XValues.Count
            '                SetCursorSeries = cnt
            '                first = False
            '            End If
            '            If TChart.Series(cnt).XValues.Count > MaxCount Then
            '                MaxCount = TChart.Series(cnt).XValues.Count
            '                SetCursorSeries = cnt
            '            End If
            '        End If
            '    Else
            '        If Not (TChart.Series(cnt).Title Is Nothing) Then
            '            If TChart.Series(cnt).Title.Trim.ToUpper = "XLABEL" Then
            '                SetCursorSeries = cnt
            '                Exit For
            '            End If
            '            If TChart.Series(cnt).Title.Trim.ToUpper = "CURSOREVENT" Then
            '                SetCursorSeries = cnt
            '                Exit For
            '            End If
            '        End If
            '    End If
            'Next
            If SetCursorSeries >= 0 Then
                For cnt = 0 To TChart.Tools.Count - 1
                    If TChart.Tools.Items(cnt).ToolType = TeeChart.EToolClass.tcCursor Then
                        TChart.Tools.Items(cnt).asTeeCursor.Series = SetCursorSeries            'NƦCs]wФu
                        Exit For
                    End If
                Next
            End If
        End Function

        ''' <summary>
        ''' NChartge
        ''' </summary>
        ''' <param name="_page"></param>
        ''' <param name="WinChart"></param>
        ''' <param name="ChartName"></param>
        ''' <param name="ChartShow"></param>
        ''' <param name="XFormat"></param>
        ''' <param name="YFormat"></param>
        ''' <param name="RegisterScript"></param>
        ''' <param name="SaveFile"></param>
        ''' <param name="OnLine"></param>
        ''' <param name="Beep"></param>
        ''' <param name="mPdate"></param>
        ''' <param name="mPid"></param>
        ''' <remarks></remarks>
        Public Shared Sub ChartToClient(ByVal _page As BaseForm, ByVal WinChart As TeeChart.TChart(), ByVal ChartName As String(), ByVal ChartShow As Boolean(), ByVal XFormat As Single, ByVal YFormat As Single, Optional ByVal RegisterScript As Boolean = True, Optional ByVal SaveFile As Boolean = True, Optional ByVal OnLine As Boolean = False, Optional ByVal Beep As Boolean = False, Optional ByVal mPdate As String = "", Optional ByVal mPid As String = "")
            Dim cnt As Integer
            Dim ChartCount As Integer = WinChart.Length
            Dim TempFileName As String
            Dim StrJSScript As String
            SetChartStatus(_page, WinChart)
            For cnt = 0 To ChartCount - 1
                If ChartShow(cnt) Then
                    If SaveFile Then
                        SetTooLLineLimit(WinChart(cnt))
                        SetCursorSeries(WinChart(cnt))
                    End If
                    TempFileName = _page.Session("ChartTmpFile" + (cnt + 1).ToString)
                    If TempFileName Is Nothing Then
                        Dim today As Date = Now
                        Dim strDay As String = today.Year.ToString + Format(today.Month, "00") + Format(today.Day, "00")
                        TempFileName = strDay + _page.Server.CreateObject("Scripting.FileSystemObject").GetTempName
                    End If
                    If SaveFile Then
                        WinChart(cnt).Export.asNative.SaveToFile(_page.Request.PhysicalApplicationPath + "ChartTemp\" + TempFileName, True)
                    End If
                    _page.Session("ChartTmpFile" + (cnt + 1).ToString) = TempFileName
                Else
                    _page.Session("ChartTmpFile" + (cnt + 1).ToString) = Nothing
                End If
            Next
            RegisterVBScript(_page, "TeeChartEventHandler", CreateChartEvent(_page, RegisterScript, ChartName, ChartShow, XFormat, YFormat, OnLine, Beep))

            StrJSScript = "var oldWindowLoad = window.onload || function(){};" + vbCrLf
            StrJSScript += "window.onload = function(){" + vbCrLf
            StrJSScript += "oldWindowLoad();" + vbCrLf
            If RegisterScript Then
                SetGridCheckBox(_page, WinChart(0).Axis.Left.GridPen.Visible, StrJSScript)
            End If

            SetChartHeight(_page, WinChart, ChartName, StrJSScript)
            SetLegendLeftPosition(_page, WinChart, ChartName, StrJSScript)
            StrJSScript += "};"
            RegisterJSScript(_page, "ExtraScript", StrJSScript)
        End Sub

        Public Shared Sub SetLegendLeftPosition(ByVal paramPage As Page, ByVal paramTChart As TeeChart.TChart(), ByVal paramChartName As String(), ByRef paramScript As String)
            For i As Int16 = 0 To paramTChart.Length - 1
                If paramTChart(i).Legend.CustomPosition = True AndAlso paramTChart(i).Legend.Left = 0 Then
                    paramScript += "document.all(""" + paramChartName(i) + """).Legend.Left=" + paramTChart(i).Width.ToString + "-" + CalcLegendWidth(paramTChart(i), paramTChart(i).Width).ToString + ";" + vbCrLf
                End If
            Next
        End Sub

        ''' <summary>
        ''' ഫColor
        ''' </summary>
        ''' <param name="_color"></param>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Shared Function VBColor(ByVal _color As Color) As System.UInt32
            'ഫColor->UInt32(TeeChart Active Color Property)
            VBColor = System.UInt32.Parse(RGB(CType(_color.R, Byte), CType(_color.G, Byte), CType(_color.B, Byte)))
        End Function

        Private Shared Sub SetGridCheckBox(ByVal paramPage As BaseForm, ByVal paramShowGrid As Boolean, ByRef paramScript As String)
            Dim ChkID As String = "UCTeeChartToolBar" & paramPage.PageID & "_Checkbox3"
            paramScript += "     document.getElementById('" & ChkID & "').checked = " & paramShowGrid.ToString.ToLower & vbCrLf
        End Sub

        ''' <summary>
        ''' oTempChartɮצW
        ''' </summary>
        ''' <param name="_page"></param>
        ''' <param name="chartNum"></param>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Private Shared Function GetChartTmpFile(ByVal _page As System.Web.UI.Page, ByVal chartNum As Integer) As String
            GetChartTmpFile = _page.Session("ChartTmpFile" + (chartNum + 1).ToString)
        End Function

        ''' <summary>
        ''' beݲChartƥ
        ''' </summary>
        ''' <param name="_page"></param>
        ''' <param name="RegisterScript"></param>
        ''' <param name="ChartName"></param>
        ''' <param name="ChartShow"></param>
        ''' <param name="XFormat"></param>
        ''' <param name="YFormat"></param>
        ''' <param name="OnLine"></param>
        ''' <param name="Beep"></param>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Private Shared Function CreateChartEvent(ByVal _page As BaseForm, ByVal RegisterScript As Boolean, ByVal ChartName As String(), ByVal ChartShow As Boolean(), ByVal XFormat As Single, ByVal YFormat As Single, Optional ByVal OnLine As Boolean = False, Optional ByVal Beep As Boolean = False) As String
            Dim cnt As Integer
            Dim FormName As String = ""
            Dim ChartNo As String
            Dim ScripString As String = ""
            Dim _fcontrol, _control, _divResultArea As System.Web.UI.Control
            Dim KeepStatus As Boolean = False
            Dim ChkRealtimeID As String = "UCRealtimeSwitch" + _page.PageID + "_ChkBoxRealtime"
            If RegisterScript Then
                For Each _fcontrol In _page.Controls
                    If _fcontrol.GetType.ToString.Trim = "System.Web.UI.HtmlControls.HtmlForm" Then
                        FormName = _fcontrol.ID
                        For cnt = 0 To ChartShow.Length - 1
                            If ChartShow(cnt) Then
                                ChartNo = "chart" + (cnt + 1).ToString
                                ScripString += "Sub " + ChartNo + "_OnCursorToolChange(Tool , X , Y , XVal ,  YVal , SeriesIndex ,ValueIndex )" + vbCrLf
                                ScripString += "    Call CursorChange(document.all(""" + ChartNo + """), X, Y, XVal, YVal, SeriesIndex, ValueIndex)" + vbCrLf
                                ScripString += "End Sub" + vbCrLf + vbCrLf

                                ScripString += "Sub " + ChartNo + "_OnClick()" + vbCrLf
                                ScripString += "    Call LegendClick(document.all(""" + ChartNo + """))" + vbCrLf
                                ScripString += "End Sub" + vbCrLf + vbCrLf
                            End If
                        Next

                        _divResultArea = _fcontrol.FindControl("DivResultArea")
                        If _divResultArea IsNot Nothing Then
                            _fcontrol = _divResultArea
                        End If

                        For Each _control In _fcontrol.Controls
                            If _control.GetType.ToString.Trim = "ASP.usercontrols_ucteecharttoolbar_ascx" Then
                                For Each _subcontrol As System.Web.UI.Control In _control.Controls
                                    Select Case _subcontrol.GetType.ToString.Trim
                                        Case "System.Web.UI.HtmlControls.HtmlInputCheckBox"
                                            If CType(_subcontrol, HtmlInputCheckBox).Attributes.Item("title").Trim.Length > 0 Then
                                                ScripString += "Sub " + _subcontrol.ClientID.Trim + "_onclick" + vbCrLf
                                                ScripString += "    Call ChkBoxFunction(document.all(""" + _subcontrol.ClientID.Trim + """))" + vbCrLf
                                                ScripString += "End Sub" + vbCrLf + vbCrLf
                                            End If
                                        Case "System.Web.UI.HtmlControls.HtmlInputButton"
                                            If CType(_subcontrol, HtmlInputButton).Attributes.Item("title").Trim.Length > 0 Then
                                                ScripString += "Sub " + _subcontrol.ClientID.Trim + "_onclick" + vbCrLf
                                                ScripString += "    Dim ChkRealtime" + vbCrLf
                                                ScripString += "    Set ChkRealtime = document.all(""" + ChkRealtimeID + """)" + vbCrLf
                                                ScripString += "    If Not ChkRealtime Is Nothing Then" + vbCrLf
                                                ScripString += "        ChkRealtime.disabled=True" + vbCrLf
                                                ScripString += "	    Call btnClick(document.all(""" + _subcontrol.ClientID.Trim + """))" + vbCrLf
                                                ScripString += "        ChkRealtime.disabled=False" + vbCrLf
                                                ScripString += "    Else" + vbCrLf
                                                ScripString += "	    Call btnClick(document.all(""" + _subcontrol.ClientID.Trim + """))" + vbCrLf
                                                ScripString += "    End If" + vbCrLf
                                                ScripString += "End Sub" + vbCrLf + vbCrLf
                                            End If
                                        Case "System.Web.UI.HtmlControls.HtmlInputHidden"
                                            If CType(_subcontrol, HtmlInputHidden).Attributes.Item("title").Trim.ToUpper = "CHARTSTATUS" Then
                                                ScripString += "Sub " + FormName + "_onsubmit()" + vbCrLf
                                                ScripString += "	Call SaveChartStatus(document.all(""" + _subcontrol.ClientID.Trim + """))" + vbCrLf
                                                ScripString += "End Sub" + vbCrLf + vbCrLf
                                            End If
                                    End Select
                                Next
                            End If
                        Next
                    End If
                Next
            End If

            Return PubScript(_page, RegisterScript, FormName, ChartName, ChartShow, XFormat, YFormat, OnLine, Beep) + ScripString.ToString
        End Function

        ''' <summary>
        ''' ChartƥScript
        ''' </summary>
        ''' <param name="_page"></param>
        ''' <param name="RegisterScript"></param>
        ''' <param name="FormName"></param>
        ''' <param name="ChartName"></param>
        ''' <param name="ChartShow"></param>
        ''' <param name="XFormat"></param>
        ''' <param name="YFormat"></param>
        ''' <param name="OnLine"></param>
        ''' <param name="Beep"></param>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Private Shared Function PubScript(ByVal _page As System.Web.UI.Page, ByVal RegisterScript As Boolean, ByVal FormName As String, ByVal ChartName As String(), ByVal ChartShow As Boolean(), ByVal XFormat As Single, ByVal YFormat As Single, Optional ByVal OnLine As Boolean = False, Optional ByVal Beep As Boolean = False) As String
            Dim script As String = ""
            Dim XLength, XDecimal, YLength, YDecimal, ChartCount, cnt As Integer
            Dim ArrayNum, ChartPath As String

            ChartPath = "http://" + _page.Request.ServerVariables.Item("HTTP_HOST") + _page.Request.ApplicationPath + "/ChartTemp/"
            'XDecimal = (XFormat - Int(XFormat)) * 10
            XDecimal = XFormat.ToString.Length - XFormat.ToString.IndexOf("."c) - 1
            'XLength = Int(XFormat) + IIf(XDecimal = 0, 0, XDecimal + 1)
            XLength = XFormat.ToString.Length
            'YDecimal = (YFormat - Int(YFormat)) * 10
            YDecimal = YFormat.ToString.Length - YFormat.ToString.IndexOf("."c) - 1
            'YLength = Int(YFormat) + IIf(YDecimal = 0, 0, YDecimal + 1)
            YLength = YFormat.ToString.Length
            ChartCount = ChartShow.Length
            ArrayNum = (ChartCount - 1).ToString

            script += "Dim Ymax(" + ArrayNum + "), Ymin(" + ArrayNum + "), Yinc(" + ArrayNum + "), Ytick(" + ArrayNum + ")" + vbCrLf
            script += "Dim YRmax(" + ArrayNum + "), YRmin(" + ArrayNum + "), YRinc(" + ArrayNum + "), YRtick(" + ArrayNum + ")" + vbCrLf
            script += "Dim ChartShow(" + ArrayNum + "), ChartName(" + ArrayNum + "),XLabelNo(" + ArrayNum + ")" + vbCrLf
            script += "Dim XChartCursorNo(" + ArrayNum + ")" + vbCrLf
            script += "Dim XLength, XDecimal, YLength, YDecimal, ArrayNum" + vbCrLf
            script += "Dim ChBox1st(20),ChBoxMid(15),ChBox1stCnt,ChBoxMidCnt,WildMark,KeepStatus" + vbCrLf
            script += "Dim ChBoxL1st(20),ChBoxLMid(15),ChBoxL1stCnt,ChBoxLMidCnt,LineMark" + vbCrLf
            script += "Dim HasBeenPaint(" + ArrayNum + ")" + vbCrLf + vbCrLf

            script += "ArrayNum=" + ArrayNum + vbCrLf
            script += "XLength=" + XLength.ToString + vbCrLf
            script += "XDecimal=" + XDecimal.ToString + vbCrLf
            script += "YLength=" + YLength.ToString + vbCrLf
            script += "YDecimal=" + YDecimal.ToString + vbCrLf
            script += "WildMark=""?""" + vbCrLf
            script += "LineMark=""_""" + vbCrLf
            script += "KeepStatus=False" + vbCrLf + vbCrLf

            For cnt = 0 To ChartCount - 1
                script += "HasBeenPaint(" + cnt.ToString + ")=False" + vbCrLf
                script += "ChartShow(" + cnt.ToString + ")=" + ChartShow(cnt).ToString + vbCrLf
                script += "ChartName(" + cnt.ToString + ")=""" + ChartName(cnt) + """" + vbCrLf
                script += "Call GetChartData(document.all(ChartName(" + cnt.ToString + ")),""" + GetChartTmpFile(_page, cnt) + """,""ChtGrid" + (cnt + 1).ToString + """)" + vbCrLf + vbCrLf
            Next

            script += "Sub GetChartData(chart,FileName,gridName)" + vbCrLf
            script += "   Dim ChartPath" + vbCrLf
            script += "   Dim ChartGrid" + vbCrLf
            'script += "   If not (document.all(gridName) is nothing) Then" + vbCrLf
            'script += "      ChartGrid = document.all(gridName)" + vbCrLf
            'script += "   End If" + vbCrLf
            script += "   If FileName<>"""" Then" + vbCrLf
            script += "      ChartPath = """ + ChartPath + """" + vbCrLf
            script += "      chart.Import.LoadFromURL(ChartPath+FileName)" + vbCrLf
            script += "      chart.Visible=True" + vbCrLf
            'script += "      If not (document.all(gridName) is nothing) Then" + vbCrLf
            'script += "        document.all(gridName).chart=chart" + vbCrLf
            'script += "        Call SetChartGrid(document.all(gridName))" + vbCrLf
            'script += "      End If" + vbCrLf
            script += "   Else" + vbCrLf
            script += "      chart.Visible=False" + vbCrLf
            script += "   End If" + vbCrLf
            script += "End Sub" + vbCrLf + vbCrLf

            If RegisterScript = False Then
                Return script.ToString
            End If

            script += "Call GetChartToolPara()" + vbCrLf
            script += "Call SaveScale()" + vbCrLf
            script += "Call ChkBoxList()" + vbCrLf + vbCrLf

            script += "Sub SetChartGrid(grid)" + vbCrLf
            ']wGridŪ
            script += "  grid.ReadOnly=True" + vbCrLf
            'D
            script += "  grid.ShowFields=False" + vbCrLf
            'XyФWLabel
            script += "  grid.ShowLabels=True" + vbCrLf
            'ùڪX Value
            script += "  grid.ShowXValues=False" + vbCrLf
            script += "End Sub" + vbCrLf + vbCrLf

            script += "Sub GetChartToolPara()" + vbCrLf
            script += "   Dim cnt" + vbCrLf
            script += "   For cnt=0 To ArrayNum" + vbCrLf
            script += "      XChartCursorNo(cnt) = GetCursorNo(document.all(""chart"" + Cstr(cnt + 1)))" + vbCrLf
            script += "      XLabelNo(cnt) = GetXLabelNo(document.all(""chart"" + Cstr(cnt + 1)))" + vbCrLf
            script += "   Next" + vbCrLf
            script += "End Sub" + vbCrLf + vbCrLf

            script += "Function GetCursorNo(chart)" + vbCrLf
            script += "   Dim cnt" + vbCrLf
            script += "   GetCursorNo = -2" + vbCrLf
            script += "   If (chart.Tools.Count>0) Then" + vbCrLf
            script += "      For cnt=0 to chart.Tools.Count-1" + vbCrLf
            script += "         If (chart.Tools.Items(cnt).ToolType = 0) Then" + vbCrLf
            script += "            GetCursorNo = cnt" + vbCrLf
            script += "            Exit For" + vbCrLf
            script += "         End If" + vbCrLf
            script += "      Next" + vbCrLf
            script += "   End If" + vbCrLf
            script += "End Function" + vbCrLf + vbCrLf

            script += "Function GetXLabelNo(chart)" + vbCrLf
            script += "   Dim cnt" + vbCrLf
            script += "   GetXLabelNo = -1" + vbCrLf
            script += "   If (chart.Tools.Count>0) Then" + vbCrLf
            script += "      For cnt=0 to chart.Tools.Count-1" + vbCrLf
            script += "         If (chart.Tools.Items(cnt).ToolType = 10) Then" + vbCrLf
            script += "            If (chart.Tools.Items(cnt).asAnnotation.Text = ""XLABEL"") Then" + vbCrLf
            script += "               chart.Tools.Items(cnt).asAnnotation.Text = """" " + vbCrLf
            script += "               GetXLabelNo = cnt" + vbCrLf
            script += "               Exit For" + vbCrLf
            script += "             End If" + vbCrLf
            script += "          End If" + vbCrLf
            script += "       Next" + vbCrLf
            script += "   End If" + vbCrLf
            script += "End Function" + vbCrLf + vbCrLf

            script += "Function CursorActive(chart)" + vbCrLf
            script += "   Dim CurSorNum" + vbCrLf
            script += "   CurSorNum = XChartCursorNo(CInt(Mid(chart.id,6,1))-1)" + vbCrLf
            script += "   If (CurSorNum < 0) Then" + vbCrLf
            script += "      CursorActive = False" + vbCrLf
            script += "   Else" + vbCrLf
            script += "      CursorActive = chart.Tools.Items(CurSorNum).Active" + vbCrLf
            script += "   End If" + vbCrLf
            script += "End Function" + vbCrLf + vbCrLf

            script += "Sub SaveScale()" + vbCrLf
            script += "   Dim chnum" + vbCrLf
            script += "   For Each chart in " + FormName + vbCrLf
            script += "      If Ucase(Mid(chart.id,1,5))=""CHART"" Then" + vbCrLf
            script += "         If (chart.Visible=True) Then" + vbCrLf
            script += "            chnum=CInt(Mid(chart.id,6,1))-1" + vbCrLf
            'script += "Msgbox ""chart.Axis.Left.Maximum="" & chart.Axis.Left.Maximum" + vbCrLf
            'script += "Msgbox ""Ymax="" & Ymax(chnum) & ""Ymin="" & Ymin(chnum)" + vbCrLf
            script += "            Ymax(chnum)=chart.Axis.Left.Maximum" + vbCrLf
            script += "            Ymin(chnum)=chart.Axis.Left.Minimum" + vbCrLf
            'script += "Msgbox ""Ymax="" & Ymax(chnum) & ""Ymin="" & Ymin(chnum)" + vbCrLf
            script += "            Yinc(chnum)=chart.Axis.Left.Increment" + vbCrLf
            script += "            Ytick(chnum)=chart.Axis.Left.MinorTickCount" + vbCrLf
            script += "            YRmax(chnum)=chart.Axis.Right.Maximum" + vbCrLf
            script += "            YRmin(chnum)=chart.Axis.Right.Minimum" + vbCrLf
            script += "            YRinc(chnum)=chart.Axis.Right.Increment" + vbCrLf
            script += "            YRtick(chnum)=chart.Axis.Right.MinorTickCount" + vbCrLf
            script += "         End If" + vbCrLf
            script += "      End If" + vbCrLf
            script += "   Next" + vbCrLf
            'script += "Msgbox ""Ymax="" & Ymax(0) & ""Ymin="" & Ymin(0)" + vbCrLf
            script += "End Sub" + vbCrLf + vbCrLf

            script += "Sub ChkBoxList()" + vbCrLf
            script += "   Dim Chbox" + vbCrLf
            script += "   Dim wildflag,wildstart,wildlen" + vbCrLf
            script += "   Chbox1stCnt = 0" + vbCrLf
            script += "   ChboxMidCnt = 0" + vbCrLf
            script += "   ChboxL1stCnt = 0" + vbCrLf
            script += "   ChboxLMidCnt = 0" + vbCrLf
            script += "   For Each Chbox in " + FormName + vbCrLf
            script += "      If UCase(ChBox.type) = ""CHECKBOX"" Then" + vbCrLf
            script += "         Call GetWildPara(Chbox.title,WildMark,wildflag,wildstart,wildlen)" + vbCrLf
            script += "         If (wildflag = True) Then" + vbCrLf
            script += "            If (wildstart = 1) Then" + vbCrLf
            script += "               ChBox1st(Chbox1stCnt) = Chbox.id" + vbCrLf
            script += "               Chbox1stCnt = Chbox1stCnt + 1" + vbCrLf
            script += "            Else" + vbCrLf
            script += "                ChBoxMid(ChboxMidCnt) = Chbox.id" + vbCrLf
            script += "                ChboxMidCnt = ChboxMidCnt + 1" + vbCrLf
            script += "            End If" + vbCrLf
            script += "         End If" + vbCrLf
            script += "         Call GetWildPara(Chbox.title,LineMark,wildflag,wildstart,wildlen)" + vbCrLf
            script += "         If (wildflag = True) Then" + vbCrLf
            script += "            If (wildstart = 1) Then" + vbCrLf
            script += "               ChBoxL1st(ChboxL1stCnt) = Chbox.id" + vbCrLf
            script += "               ChboxL1stCnt = ChboxL1stCnt + 1" + vbCrLf
            script += "            Else" + vbCrLf
            script += "               ChBoxLMid(ChboxLMidCnt) = Chbox.id" + vbCrLf
            script += "               ChboxLMidCnt = ChboxLMidCnt + 1" + vbCrLf
            script += "            End If" + vbCrLf
            script += "		    End If" + vbCrLf
            script += "      End If" + vbCrLf
            script += "   Next" + vbCrLf
            script += "End Sub" + vbCrLf + vbCrLf


            script += "Sub GetWildPara(ByVal title,ByVal Mark,ByRef wildflag,ByRef wildstart,ByRef wildlen)" + vbCrLf
            script += "   Dim Cnt,strlen" + vbCrLf
            script += "   strlen = Len(title)" + vbCrLf
            script += "   wildflag = False" + vbCrLf
            script += "   For cnt = 1 To strlen" + vbCrLf
            script += "      If Mid(title,cnt,1)=Mark Then" + vbCrLf
            script += "         If (wildflag = False) Then" + vbCrLf
            script += "            wildflag = True" + vbCrLf
            script += "            wildstart = cnt" + vbCrLf
            script += "            wildlen = 1" + vbCrLf
            script += "         Else" + vbCrLf
            script += "            wildlen = wildlen + 1" + vbCrLf
            script += "         End If" + vbCrLf
            script += "      Else" + vbCrLf
            script += "         If (wildflag = True) Then" + vbCrLf
            script += "            Exit For" + vbCrLf
            script += "         End If" + vbCrLf
            script += "      End If" + vbCrLf
            script += "   Next" + vbCrLf
            script += "End Sub" + vbCrLf + vbCrLf

            script += "Sub ChkBoxFunction(CheckBox1)" + vbCrLf
            script += "   Select Case Ucase(CheckBox1.Title)" + vbCrLf
            script += "          Case ""CURSOR""" + vbCrLf
            script += "               Call ShowCursor(Checkbox1)" + vbCrLf
            script += "          Case ""LEGEND""" + vbCrLf
            script += "               Call ShowLegend(Checkbox1)" + vbCrLf
            script += "          Case ""GRID""" + vbCrLf
            script += "               Call ShowGrid(Checkbox1)" + vbCrLf
            script += "          Case Else" + vbCrLf
            script += "               If UCase(Mid(CheckBox1.Title,1,8))=""TOOLLINE"" Then" + vbCrLf
            script += "                  Dim ChartNo,LineNo" + vbCrLf
            script += "                  ChartNo=Split(Mid(CheckBox1.Title,9),"":"")" + vbCrLf
            script += "                  If (CInt(ChartNo(0)) > 0) Then" + vbCrLf
            script += "                     LineNo=Split(ChartNo(1),""-"")" + vbCrLf
            script += "                     Call ShowToolLine(Checkbox1,document.all(""chart""+ChartNo(0)),CInt(LineNo(0)),CInt(LineNo(1)))" + vbCrLf
            script += "                  End If" + vbCrLf
            script += "               Else" + vbCrLf
            script += "                  Call ShowLine(Checkbox1)" + vbCrLf
            script += "               End If" + vbCrLf
            script += "   End Select" + vbCrLf
            script += "End Sub" + vbCrLf + vbCrLf

            script += "Sub btnClick(Button1)" + vbCrLf
            script += "   Select Case UCase(Button1.title)" + vbCrLf
            script += "          Case ""AUTOSCALE""" + vbCrLf
            script += "               Call AutoScale(Space(0))" + vbCrLf
            script += "          Case ""CHGSCALE""" + vbCrLf
            script += "               Call ChangeScale(Button1)" + vbCrLf
            script += "          Case ""PRINT""" + vbCrLf
            script += "               Call ShowPrePrint(Button1)" + vbCrLf
            script += "          Case ""OUTDATA""" + vbCrLf
            script += "               Call ShowExport(Button1)" + vbCrLf
            script += "   End Select" + vbCrLf
            script += "End Sub" + vbCrLf + vbCrLf

            script += "Sub SaveChartStatus(Text1)" + vbCrLf
            script += "dim x" + vbCrLf
            script += "   Dim strStatus,first" + vbCrLf
            script += "   strStatus = """" " + vbCrLf
            script += "   first = True " + vbCrLf

            script += "   For Each chart in " + FormName + vbCrLf
            script += "      If Ucase(Mid(chart.id,1,5))=""CHART"" Then" + vbCrLf

            script += "         If (first=True) Then" + vbCrLf
            script += "            first = False" + vbCrLf

            script += "         Else" + vbCrLf
            script += "            strStatus = strStatus+"";"" " + vbCrLf
            script += "         End If" + vbCrLf


            script += "         For x=0 to  chart.SeriesCount-1" + vbCrLf

            script += "             If (chart.Series(x).Active = True) Then" + vbCrLf

            script += "                strStatus = strStatus + ""T"" " + vbCrLf

            script += "             Else" + vbCrLf
            script += "                strStatus = strStatus + ""F"" " + vbCrLf

            script += "             End If" + vbCrLf
            script += "         Next" + vbCrLf
            script += "      End If" + vbCrLf
            script += "   Next" + vbCrLf
            'script += " msgbox strStatus" + vbCrLf
            script += "   Text1.value = strStatus" + vbCrLf
            script += "End Sub" + vbCrLf + vbCrLf


            script += "Sub ShowPrePrint(Button1)" + vbCrLf
            script += "   Dim ChartNo,chname" + vbCrLf
            script += "   Button1.disabled=True" + vbCrLf
            script += "   ChartNo = GetSelectChart()" + vbCrLf
            script += "   If (ChartNo > 0) Then" + vbCrLf
            script += "      chname =""chart"" + Cstr(ChartNo)" + vbCrLf
            script += "      " + FormName + ".Item(chname).Printer.ShowPreview()" + vbCrLf
            script += "   End If" + vbCrLf
            script += "   Button1.disabled=False" + vbCrLf
            script += "End Sub" + vbCrLf + vbCrLf + vbCrLf

            script += "Sub ShowExport(Button1)" + vbCrLf
            script += "   Dim ChartNo,chname" + vbCrLf
            script += "   Button1.disabled=True" + vbCrLf
            script += "   ChartNo = GetSelectChart()" + vbCrLf
            script += "   If (ChartNo > 0) Then" + vbCrLf
            script += "      chname =""chart"" + Cstr(ChartNo)" + vbCrLf
            script += "      " + FormName + ".Item(chname).Export.ShowExport()" + vbCrLf
            script += "   End If" + vbCrLf
            script += "   Button1.disabled=False" + vbCrLf
            script += "End Sub" + vbCrLf + vbCrLf + vbCrLf

            script += "Sub ShowToolLine(Checkbox1,Chart,StartNo,EndNo)" + vbCrLf
            script += "   Dim cnt,SeriesNum" + vbCrLf
            script += "   For cnt = StartNo To EndNo" + vbCrLf
            script += "      SeriesNum = ToolSeriesNo(chart,cnt)" + vbCrLf
            script += "      If (SeriesNum >= 0) Then" + vbCrLf
            script += "         chart.Series(SeriesNum).Active = CheckBox1.Checked" + vbCrLf
            script += "      End If" + vbCrLf
            script += "   Next" + vbCrLf
            script += "End Sub" + vbCrLf + vbCrLf

            script += "Function ToolSeriesNo(chart,ToolLineNum)" + vbCrLf
            script += "   Dim cnt,Line" + vbCrLf
            script += "   ToolSeriesNo=-1" + vbCrLf
            script += "   For cnt = 0 To chart.SeriesCount-1" + vbCrLf
            script += "      If (chart.Series(cnt).ShowInLegend = False) Then" + vbCrLf
            script += "         If (IsNull(chart.Series(cnt).title)=False) Then" + vbCrLf
            script += "            If (len(chart.Series(cnt).title)>9) Then" + vbCrLf
            script += "               If UCase(Mid(chart.Series(cnt).title,1,9))=""TOOLLINE:"" Then" + vbCrLf
            script += "                  Line=Split(chart.Series(cnt).title,"":"")" + vbCrLf
            script += "                  If (CInt(Line(1))=ToolLineNum) Then" + vbCrLf
            script += "                     ToolSeriesNo=cnt" + vbCrLf
            script += "                     Exit For" + vbCrLf
            script += "                  End If" + vbCrLf
            script += "               End If" + vbCrLf
            script += "            End If" + vbCrLf
            script += "         End If" + vbCrLf
            script += "      End If" + vbCrLf
            script += "   Next" + vbCrLf
            script += "End Function" + vbCrLf + vbCrLf

            script += "Sub ShowCursor(Checkbox1)" + vbCrLf
            script += "   Dim cnt,i,j,k" + vbCrLf + vbCrLf
            script += "   For Each chart in " + FormName + vbCrLf
            script += "      If Ucase(Mid(chart.id,1,5))=""CHART"" Then" + vbCrLf
            script += "         For cnt=0 to  chart.Tools.Count-1" + vbCrLf
            script += "             If (chart.Tools.Items(cnt).ToolType = 0) Then" + vbCrLf
            script += "                chart.Tools.Items(cnt).Active=Checkbox1.checked" + vbCrLf
            script += "                Exit For" + vbCrLf
            script += "             End If" + vbCrLf
            script += "         Next" + vbCrLf
            script += "         Call SetAnnotationStatus(chart)" + vbCrLf
            script += "      End If" + vbCrLf
            script += "   Next" + vbCrLf
            script += "End Sub" + vbCrLf + vbCrLf

            script += "Sub ShowLine(CheckBox1)" + vbCrLf
            script += "   Dim cnt,ArrayCnt,CursorNo" + vbCrLf
            script += "   Dim wildflag,wildstart,wildlen,Lineflag,Linestart,Linelen" + vbCrLf
            script += "   Call GetWildPara(CheckBox1.title,WildMark,wildflag,wildstart,wildlen)" + vbCrLf
            script += "   Call GetWildPara(CheckBox1.title,LineMark,Lineflag,Linestart,Linelen)" + vbCrLf
            script += "   For Each chart in " + FormName + vbCrLf
            script += "      If Ucase(Mid(chart.id,1,5))=""CHART"" Then" + vbCrLf
            script += "         For cnt=0 to chart.SeriesCount-1" + vbCrLf
            script += "            If (chart.Series(cnt).ShowInLegend = True) Then" + vbCrLf
            script += "               If (IsNull(chart.Series(cnt).title) = False) Then" + vbCrLf
            script += "                  If (wildflag = False) And (Lineflag = False) Then" + vbCrLf
            script += "                     If Ucase(chart.Series(cnt).Title) = UCase(Mid(CheckBox1.Title,1,Len(chart.Series(cnt).Title))) Then" + vbCrLf
            script += "                        chart.Series(cnt).Active = CheckBox1.Checked" + vbCrLf
            script += "                        Exit For" + vbCrLf
            script += "                     End If " + vbCrLf
            script += "                  ElseIf (wildflag = True) Then" + vbCrLf
            script += "                     Call ShowWildLine(chart,cnt,CheckBox1,wildstart,wildlen)" + vbCrLf
            script += "                  ElseIf (Lineflag = True) Then" + vbCrLf
            script += "                     Call ShowFlagLine(chart,cnt,CheckBox1,Linestart,Linelen)" + vbCrLf
            script += "                  End If" + vbCrLf
            script += "               End If" + vbCrLf
            script += "            End If" + vbCrLf
            script += "         Next" + vbCrLf
            script += "         If (CursorActive(chart) = True) Then" + vbCrLf
            script += "            SetAnnotationStatus(chart)" + vbCrLf
            script += "         End If" + vbCrLf
            script += "      End if" + vbCrLf
            script += "   Next" + vbCrLf
            script += "End Sub" + vbCrLf + vbCrLf

            script += "Sub ShowFlagLine(chart,SeriesNo,CheckBox1,Linestart,Linelen)" + vbCrLf
            script += "   Dim IsEnable,ArrayCnt,SeriesNum" + vbCrLf
            script += "   If (Linestart = 1) Then" + vbCrLf
            'script += "     If UCase(Mid(chart.Series(SeriesNo).Title,Linelen+1)) = UCase(Mid(CheckBox1.Title,Linelen+1)) Then" + vbCrLf
            script += "         For ArrayCnt = 0 To ChBoxLMidCnt-1" + vbCrLf
            script += "            If UCase(Mid(document.all(ChBoxLMid(ArrayCnt)).title,Linestart,Linelen))=UCase(Mid(chart.Series(SeriesNo).title,Linestart,Linelen)) Then" + vbCrLf
            script += "               IsEnable = (document.all(ChBoxLMid(ArrayCnt)).Checked=True) And (CheckBox1.Checked=True)" + vbCrLf
            script += "               SeriesNum = ToolSeriesNo(chart,SeriesNo)" + vbCrLf
            script += "               If (SeriesNum >= 0) Then" + vbCrLf
            script += "                  chart.Series(SeriesNum).Active = IsEnable" + vbCrLf
            script += "               End If" + vbCrLf
            script += "               Exit for" + vbCrLf
            script += "            End If" + vbCrLf
            script += "         Next" + vbCrLf
            'script += "     End If" + vbCrLf
            script += "   Else" + vbCrLf
            script += "      If UCase(Mid(chart.Series(SeriesNo).title,1,Linestart-1)) = UCase(Mid(CheckBox1.title,1,Linestart-1)) Then" + vbCrLf
            script += "         chart.Series(SeriesNo).Active = CheckBox1.Checked" + vbCrLf
            script += "         For ArrayCnt = 0 To ChBoxL1stCnt-1" + vbCrLf
            script += "            If (UCase(Mid(document.all(ChBoxL1st(ArrayCnt)).title,1,1))=LineMark) Then" + vbCrLf
            script += "               IsEnable = (document.all(ChBoxL1st(ArrayCnt)).Checked=True) And (CheckBox1.Checked=True)" + vbCrLf
            script += "               SeriesNum = ToolSeriesNo(chart,SeriesNo)" + vbCrLf
            script += "               If (SeriesNum >= 0) Then" + vbCrLf
            script += "                  chart.Series(SeriesNum).Active = IsEnable" + vbCrLf
            script += "               End If" + vbCrLf
            script += "               Exit for" + vbCrLf
            script += "            End If" + vbCrLf
            script += "         Next" + vbCrLf
            script += "      End If" + vbCrLf
            script += "   End If" + vbCrLf
            script += "End Sub" + vbCrLf + vbCrLf


            script += "Sub ShowWildLine(chart,SeriesNo,CheckBox1,wildstart,wildlen)" + vbCrLf
            script += "   Dim IsEnable,ArrayCnt" + vbCrLf
            script += "   If (wildstart = 1) Then" + vbCrLf
            script += "      If UCase(Mid(chart.Series(SeriesNo).Title,wildlen+1)) = UCase(Mid(CheckBox1.Title,wildlen+1)) Then" + vbCrLf
            script += "         For ArrayCnt = 0 To ChBoxMidCnt-1" + vbCrLf
            script += "            If UCase(Mid(document.all(ChBoxMid(ArrayCnt)).title,wildstart,wildlen))=UCase(Mid(chart.Series(SeriesNo).Title,wildstart,wildlen)) Then" + vbCrLf
            script += "               IsEnable = (document.all(ChBoxMid(ArrayCnt)).Checked=True) And (CheckBox1.Checked=True)" + vbCrLf
            script += "               chart.Series(SeriesNo).Active = IsEnable" + vbCrLf
            script += "               Exit for" + vbCrLf
            script += "            End If" + vbCrLf
            script += "         Next" + vbCrLf
            script += "      End If" + vbCrLf
            script += "   Else" + vbCrLf
            script += "      If UCase(Mid(chart.Series(SeriesNo).Title,1,wildstart-1)) = UCase(Mid(CheckBox1.Title,1,wildstart-1)) Then" + vbCrLf
            script += "         For ArrayCnt = 0 To ChBox1stCnt-1" + vbCrLf
            script += "            If UCase(Mid(document.all(ChBox1st(ArrayCnt)).title,wildstart))=UCase(Mid(chart.Series(SeriesNo).Title,wildstart)) Then" + vbCrLf
            script += "               IsEnable = (document.all(ChBox1st(ArrayCnt)).Checked=True) And (CheckBox1.Checked=True)" + vbCrLf
            script += "               chart.Series(SeriesNo).Active = IsEnable" + vbCrLf
            script += "               Exit for" + vbCrLf
            script += "            End If" + vbCrLf
            script += "         Next" + vbCrLf
            script += "      End If" + vbCrLf
            script += "   End If" + vbCrLf
            script += "End Sub" + vbCrLf + vbCrLf


            script += "Sub AutoScale(force)" + vbCrLf
            script += "   Dim cnt,chnum" + vbCrLf
            script += "   For Each chart in " + FormName + vbCrLf
            script += "      If Ucase(Mid(chart.id,1,5))=""CHART"" Then" + vbCrLf
            script += "         chnum=CInt(Mid(chart.id,6,1))-1" + vbCrLf
            script += "         If (chart.Axis.Left.Automatic = False And (force=Space(0))) Or (force=True) Then" + vbCrLf
            script += "             chart.Axis.Left.Automatic = True" + vbCrLf
            script += "         Else " + vbCrLf
            script += "             chart.Axis.Left.Automatic = False" + vbCrLf
            script += "             chart.Axis.Left.Maximum=Ymax(chnum)" + vbCrLf
            script += "             chart.Axis.Left.Minimum=Ymin(chnum)" + vbCrLf
            script += "             chart.Axis.Left.Increment=Yinc(chnum)" + vbCrLf
            script += "             chart.Axis.Left.MinorTickCount=Ytick(chnum)" + vbCrLf
            script += "         End If" + vbCrLf
            script += "         If (chart.Axis.Right.Visible = True) Then" + vbCrLf
            script += "            If (chart.Axis.Right.Automatic = False And (force=Space(0))) Or (force=True) Then" + vbCrLf
            script += "               chart.Axis.Right.Automatic = True" + vbCrLf
            script += "            Else " + vbCrLf
            script += "               chart.Axis.Right.Automatic = False" + vbCrLf
            script += "               chart.Axis.Right.Maximum=YRmax(chnum)" + vbCrLf
            script += "               chart.Axis.Right.Minimum=YRmin(chnum)" + vbCrLf
            script += "               chart.Axis.Right.Increment=YRinc(chnum)" + vbCrLf
            script += "               chart.Axis.Right.MinorTickCount=YRtick(chnum)" + vbCrLf
            script += "            End If" + vbCrLf
            script += "         End If" + vbCrLf
            script += "      End If" + vbCrLf
            script += "   Next" + vbCrLf
            script += "End Sub" + vbCrLf + vbCrLf

            script += "Sub ShowLegend(CheckBox1)" + vbCrLf
            script += "   For Each chart in " + FormName + vbCrLf
            script += "      If Ucase(Mid(chart.id,1,5))=""CHART"" Then" + vbCrLf
            script += "         chart.Legend.Visible=CheckBox1.Checked" + vbCrLf
            script += "      End If" + vbCrLf
            script += "   Next" + vbCrLf
            script += "End Sub" + vbCrLf + vbCrLf

            script += "Sub ShowGrid(CheckBox1)" + vbCrLf
            script += "   Dim cnt" + vbCrLf
            script += "   For Each chart in " + FormName + vbCrLf
            script += "      If Ucase(Mid(chart.id,1,5))=""CHART"" Then" + vbCrLf
            script += "         chart.Axis.Left.GridPen.Visible=CheckBox1.Checked" + vbCrLf
            script += "         chart.Axis.Right.GridPen.Visible=CheckBox1.Checked" + vbCrLf
            script += "         chart.Axis.Bottom.GridPen.Visible=CheckBox1.Checked" + vbCrLf
            script += "      End If" + vbCrLf
            script += "   Next" + vbCrLf
            script += "End Sub" + vbCrLf + vbCrLf


            script += "Function GetSeriesData(chart , SeriesNum , ValueIndex , XValue)" + vbCrLf
            script += "   Dim Tstr,Index,found" + vbCrLf
            script += "   If (chart.Series(SeriesNum).XValues.Count > 0) Then" + vbCrLf
            script += "      found=False" + vbCrLf
            script += "      For Index=0 To chart.Series(SeriesNum).XValues.Count-1" + vbCrLf
            script += "         If (chart.Series(SeriesNum).XValues.Value(Index) = XValue)  Then" + vbCrLf
            script += "            found=True" + vbCrLf
            script += "            Exit For" + vbCrLf
            script += "         End If" + vbCrLf
            script += "      Next" + vbCrLf
            script += "      If found=True Then" + vbCrLf
            script += "         Tstr = Cstr(FormatNumber(chart.Series(SeriesNum).YValues.Value(Index),YDecimal))" + vbCrLf
            script += "      Else" + vbCrLf
            script += "         Tstr=Space(0)" + vbCrLf
            script += "      End If" + vbCrLf
            script += "   End If" + vbCrLf
            script += "   GetSeriesData = TransData(Tstr,YLength)" + vbCrLf
            script += "End Function" + vbCrLf + vbCrLf

            script += "Function TransData(data,strlen)" + vbCrLf
            script += "   Dim cnt" + vbCrLf
            script += "   cnt = Len(data)" + vbCrLf
            script += "   cnt = strlen-cnt" + vbCrLf
            script += "   If cnt < 0 then" + vbCrLf
            script += "      cnt=0" + vbCrLf
            script += "   End If" + vbCrLf
            script += "   TransData=Space(cnt)+data" + vbCrLf
            script += "End Function" + vbCrLf + vbCrLf

            script += "Sub SetCursorSeries(chart)" + vbCrLf
            script += "   Dim cnt,CursorNo,MaxValue,CursorSeries" + vbCrLf
            script += "   CursorNo = XChartCursorNo(CInt(Mid(chart.id,6,1))-1)" + vbCrLf
            script += "   If (CursorNo >= 0) AND (XLabelNo(CInt(Mid(chart.id,6,1))-1)<0) Then" + vbCrLf
            script += "      MaxValue= -1" + vbCrLf
            script += "      For cnt = 0 To chart.SeriesCount - 1" + vbCrLf
            script += "         If (chart.Series(cnt).ShowInLegend = True) Then" + vbCrLf
            script += "            If (chart.Series(cnt).XValues.Maximum > MaxValue) Then" + vbCrLf
            script += "               MaxValue=chart.Series(cnt).XValues.Maximum" + vbCrLf
            script += "               CursorSeries=cnt" + vbCrLf
            script += "            End If" + vbCrLf
            script += "         Else" + vbCrLf
            script += "            If (IsNull(chart.Series(cnt).title) = False) Then" + vbCrLf
            script += "               If (UCase(chart.Series(cnt).title) = ""XLABEL"") Then" + vbCrLf
            script += "                  MaxValue=chart.Series(cnt).XValues.Maximum" + vbCrLf
            script += "                  CursorSeries=cnt" + vbCrLf
            script += "                  Exit for" + vbCrLf
            script += "                End If" + vbCrLf
            script += "               If (UCase(chart.Series(cnt).title) = ""CURSOREVENT"") Then" + vbCrLf
            script += "                  MaxValue=chart.Series(cnt).XValues.Maximum" + vbCrLf
            script += "                  CursorSeries=cnt" + vbCrLf
            script += "                  Exit for" + vbCrLf
            script += "                End If" + vbCrLf
            script += "            End If" + vbCrLf
            script += "         End If" + vbCrLf
            script += "      Next" + vbCrLf
            script += "      If (MaxValue > 0) Then" + vbCrLf
            script += "         chart.Tools(CursorNo).asTeeCursor.Series = CursorSeries" + vbCrLf
            script += "      End If" + vbCrLf
            script += "   End If" + vbCrLf
            script += "End Sub" + vbCrLf + vbCrLf

            script += "Function ChkSeriesActiveChange(chart)" + vbCrLf
            script += "   Dim SeriseCnt,AnnoteCnt,CursorNum,cnt" + vbCrLf
            script += "   ChkSeriesActiveChange = False" + vbCrLf
            script += "   If (CursorActive(chart) = True) Then" + vbCrLf
            script += "      SeriseCnt = 0" + vbCrLf
            script += "      AnnoteCnt = 0" + vbCrLf
            script += "      CurSorNum = XChartCursorNo(CInt(Mid(chart.id,6,1))-1)" + vbCrLf
            script += "      For cnt = 0 To (chart.SeriesCount - 1)" + vbCrLf
            script += "         If (chart.Series(cnt).ShowInLegend = True) Then" + vbCrLf
            script += "            If (chart.Series(cnt).Active = True) Then" + vbCrLf
            script += "               SeriseCnt = SeriseCnt+1" + vbCrLf
            script += "            End If" + vbCrLf
            script += "            If (chart.Tools.Items(CurSorNum + cnt +2).Active = True) Then" + vbCrLf
            script += "               AnnoteCnt = AnnoteCnt+1" + vbCrLf
            script += "            End If" + vbCrLf
            script += "         End If" + vbCrLf
            script += "      Next" + vbCrLf
            script += "      If (AnnoteCnt <> SeriseCnt) Then" + vbCrLf
            script += "         ChkSeriesActiveChange = True" + vbCrLf
            script += "      End If" + vbCrLf
            script += "   End If" + vbCrLf
            script += "End Function" + vbCrLf + vbCrLf

            script += "Sub ShowAnnotation(chart,AnnotationNo,ValueIndex,XValue)" + vbCrLf
            script += "   Dim cnt,No" + vbCrLf
            script += "   No = 0" + vbCrLf
            script += "   For cnt = 0 To chart.SeriesCount - 1" + vbCrLf
            script += "      If (chart.Series(cnt).ShowInLegend = True) AND (chart.Series(cnt).Active = True) Then" + vbCrLf
            script += "         chart.Tools.Items(AnnotationNo + No).asAnnotation.Text = GetSeriesData(chart, cnt, ValueIndex, XValue)" + vbCrLf
            script += "         No = No+1" + vbCrLf
            script += "      End If" + vbCrLf
            script += "   Next" + vbCrLf
            script += "End Sub" + vbCrLf + vbCrLf

            script += "Sub SetAnnotationStatus(chart)" + vbCrLf
            script += "   Dim cnt,No,No1,XLabelNum,CurStatus,XLabelOffset,CursorNum" + vbCrLf
            script += "   CursorNum = XChartCursorNo(CInt(Mid(chart.id,6,1))-1)" + vbCrLf
            script += "   AnnotationNo = CursorNum+1" + vbCrLf
            script += "   If (AnnotationNo > 0) Then" + vbCrLf
            script += "      CurStatus = chart.Tools.Items(CursorNum).Active" + vbCrLf
            script += "      If (XLength = 0) Then" + vbCrLf
            script += "         chart.Tools.Items(AnnotationNo).Active = False" + vbCrLf
            script += "      Else" + vbCrLf
            script += "         chart.Tools.Items(AnnotationNo).Active = CurStatus" + vbCrLf
            script += "      End If" + vbCrLf
            script += "      No = 0" + vbCrLf
            script += "      AnnotationNo = AnnotationNo+1" + vbCrLf
            script += "      For cnt = 0 To chart.SeriesCount - 1" + vbCrLf
            script += "         If (chart.Series(cnt).ShowInLegend = True) AND (chart.Series(cnt).Active = True) Then" + vbCrLf
            script += "            chart.Tools.Items(AnnotationNo + No).Active = CurStatus" + vbCrLf
            script += "            chart.Tools.Items(AnnotationNo + No).asAnnotation.Shape.Font.Color = chart.Series(cnt).Color" + vbCrLf
            script += "            No = No+1" + vbCrLf
            script += "         End If" + vbCrLf
            script += "      Next" + vbCrLf
            script += "      No1=No" + vbCrLf
            script += "      For cnt = 0 To chart.SeriesCount - 1" + vbCrLf
            script += "         If (chart.Series(cnt).ShowInLegend = True) AND (chart.Series(cnt).Active = False) Then" + vbCrLf
            script += "            chart.Tools.Items(AnnotationNo + No1).Active = False" + vbCrLf
            script += "            No1=No1+1" + vbCrLf
            script += "         End If" + vbCrLf
            script += "      Next" + vbCrLf
            script += "      XLabelNum = XLabelNo(CInt(Mid(chart.id,6,1))-1)" + vbCrLf
            script += "      If (XLabelNum >= 0) Then" + vbCrLf
            script += "         XLabelOffset = 0" + vbCrLf
            script += "         If (AnnotationNo+No = XLabelNum) Then" + vbCrLf
            script += "            No = No - 1" + vbCrLf
            script += "            XLabelOffset=chart.Tools.Items(AnnotationNo + No).asAnnotation.Shape.Left-chart.Tools.Items(AnnotationNo + No-1).asAnnotation.Shape.Left" + vbCrLf
            script += "         End If" + vbCrLf
            script += "         chart.Tools.Items(XLabelNum).asAnnotation.Shape.Top = chart.Tools.Items(AnnotationNo + No).asAnnotation.Shape.Top" + vbCrLf
            script += "         chart.Tools.Items(XLabelNum).asAnnotation.Shape.Left = chart.Tools.Items(AnnotationNo + No).asAnnotation.Shape.Left+XLabelOffset" + vbCrLf
            script += "         chart.Tools.Items(XLabelNum).Active = CurStatus" + vbCrLf
            script += "      End If" + vbCrLf
            script += "      SetCursorSeries(chart)" + vbCrLf
            script += "      If (CurStatus = True) Then" + vbCrLf
            'CursorChange(chart,X,Y,XVal,YVal,SeriesIndex,ValueIndex)
            script += "         Call CursorChange(chart, 0,0, chart.Tools.Items(CursorNum).asTeeCursor.XVal, chart.Tools.Items(CursorNum).asTeeCursor.YVal, chart.Tools.Items(CursorNum).asTeeCursor.Series, 0)" + vbCrLf
            script += "      End If" + vbCrLf
            'script += "      SaveChartStatus(statusTxb)" + vbCrLf
            script += "   End If" + vbCrLf
            script += "End Sub" + vbCrLf + vbCrLf

            script += "Sub CursorChange(chart,X,Y,XVal,YVal,SeriesIndex,ValueIndex)" + vbCrLf
            script += "   Dim AnnotationNo,XLabelNum" + vbCrLf
            script += "   AnnotationNo = XChartCursorNo(CInt(Mid(chart.id,6,1))-1)+1" + vbCrLf
            script += "   If (XLength = 0) Then" + vbCrLf
            script += "      chart.Tools.Items(AnnotationNo).Active = False" + vbCrLf
            script += "   Else" + vbCrLf
            script += "      If chart.Series(SeriesIndex).XValues.DateTime Then" + vbCrLf
            script += "         chart.Tools.Items(AnnotationNo).asAnnotation.Text = ""#"" + Cstr(chart.Series(SeriesIndex).XValues.Locate(XVal)+1)" + vbCrLf
            script += "      Else" + vbCrLf
            script += "         chart.Tools.Items(AnnotationNo).asAnnotation.Text = ""X:"" + GetXData(XVal)" + vbCrLf
            script += "      End If" + vbCrLf
            script += "   End If" + vbCrLf
            script += "   Call ShowAnnotation(chart, AnnotationNo + 1, ValueIndex, XVal)" + vbCrLf
            script += "   XLabelNum = XLabelNo(CInt(Mid(chart.id,6,1))-1)" + vbCrLf
            script += "   If (XLabelNum >= 0) Then" + vbCrLf
            script += "      chart.Tools.Items(XLabelNum).asAnnotation.Text =  GetLabelStr(chart,X,Y,XVal,YVal,SeriesIndex,ValueIndex)" + vbCrLf
            script += "   End If" + vbCrLf
            script += "End Sub" + vbCrLf

            script += "Sub LegendClick(chart)" + vbCrLf
            script += "   If (CursorActive(chart) = True) Then" + vbCrLf
            script += "      If (ChkSeriesActiveChange(chart) = True) Then" + vbCrLf
            script += "         SetAnnotationStatus(chart)" + vbCrLf
            script += "      End If" + vbCrLf
            script += "   End If" + vbCrLf
            script += "End Sub" + vbCrLf

            script += "Function GetLabelStr(chart,X,Y,XVal,YVal,SeriesIndex,ValueIndex)" + vbCrLf
            script += "   Dim cnt" + vbCrLf
            script += "   GetLabelStr=""""" + vbCrLf
            script += "   If (chart.Series(SeriesIndex).XValues.Count > 0) Then" + vbCrLf
            script += "      For cnt = 0 To chart.SeriesCount - 1" + vbCrLf
            script += "         If chart.Series(cnt).ShowInLegend = False Then" + vbCrLf
            script += "            If Ucase(chart.Series(cnt).Title) = ""XLABEL"" Then" + vbCrLf
            script += "               GetLabelStr=chart.Series(cnt).ValueMarkText(ValueIndex)" + vbCrLf
            script += "               Exit For" + vbCrLf
            script += "            End If" + vbCrLf
            script += "         End If" + vbCrLf
            script += "      Next" + vbCrLf
            script += "   End If" + vbCrLf
            script += "End Function" + vbCrLf

            script += "Function GetXData(ByVal XVal)" + vbCrLf
            script += "   Dim Tstr" + vbCrLf
            script += "   If (IsNumeric(XVal) = True) Then" + vbCrLf
            script += "      Tstr = TransData(CStr(FormatNumber(XVal, XDecimal)), XLength)" + vbCrLf
            script += "   ElseIf (IsNull(XVal) = True) Then" + vbCrLf
            script += "      Tstr = Space(0)" + vbCrLf
            script += "   Else" + vbCrLf
            script += "      Tstr = CStr(Xval)" + vbCrLf
            script += "   End If" + vbCrLf
            script += "   GetXData = Tstr" + vbCrLf
            script += "End Function" + vbCrLf + vbCrLf

            script += "Sub ChangeScale(Button1)" + vbCrLf
            script += "   Dim ScaleString" + vbCrLf
            'script += "   Button1.Disabled = True" + vbCrLf
            script += "   ScaleString = Window.ShowModalDialog(""" & _page.Request.ApplicationPath & "/Forms/Common/ChgScalePopup.aspx"", AssemblyScaleString(), ""dialogWidth:460px;dialogHeight:500px;help:no;status:no;resizable:yes"")" + vbCrLf
            script += "   Call SplitScaleString(ScaleString)" + vbCrLf
            'script += "   Button1.Disabled = False" + vbCrLf
            script += "End Sub" + vbCrLf + vbCrLf

            script += "Function GetSelectChart()" + vbCrLf
            script += "   Dim ChartNo" + vbCrLf
            script += "   ChartNo = 1" + vbCrLf
            script += "   If (ArrayNum > 0) Then" + vbCrLf
            script += "      ChartNo = Window.ShowModalDialog(""" & _page.Request.ApplicationPath & "/Forms/Common/SelChartPopup.aspx"", AssemblyChartNameString(), ""dialogWidth:260px;dialogHeight:350px;help:no;status:no;resizable:yes"")" + vbCrLf
            script += "   End If" + vbCrLf
            script += "   GetSelectChart = ChartNo" + vbCrLf
            script += "End Function" + vbCrLf + vbCrLf

            script += "Function AssemblyScaleString()" + vbCrLf
            script += "   Dim ChNum,ChartNM,ChartStr" + vbCrLf
            script += "   ChartStr = Space(0)" + vbCrLf
            script += "   For ChNum = 0 To ArrayNum" + vbCrLf
            script += "      ChartNM=""chart""+Cstr(ChNum+1)" + vbCrLf
            script += "      ChartStr = ChartStr + form1.item(ChartNM).Header.Text.Text + """" + Mid(CStr(ChartShow(ChNum)), 1, 1) + """"" + vbCrLf
            script += "      ChartStr = ChartStr + CStr(Ymax(ChNum)) + """" + CStr(Ymin(ChNum)) + """" + CStr(Yinc(ChNum)) + """" + CStr(Ytick(ChNum)) + """"" + vbCrLf
            script += "      If (form1.item(ChartNM).Axis.Right.Visible=True) Then" + vbCrLf
            script += "         ChartStr = ChartStr + ""T""" + vbCrLf
            script += "      Else" + vbCrLf
            script += "         ChartStr = ChartStr + ""F""" + vbCrLf
            script += "      End If" + vbCrLf
            script += "      ChartStr = ChartStr + CStr(YRmax(ChNum)) + """" + CStr(YRmin(ChNum)) + """" + CStr(YRinc(ChNum)) + """" + CStr(YRtick(ChNum))" + vbCrLf
            script += "      If (ChNum < ArrayNum) Then" + vbCrLf
            script += "         ChartStr = ChartStr + """"" + vbCrLf
            script += "      End If" + vbCrLf
            script += "   Next" + vbCrLf
            script += "   AssemblyScaleString = ChartStr" + vbCrLf
            script += "End Function" + vbCrLf + vbCrLf

            script += "Function AssemblyChartNameString()" + vbCrLf
            script += "   Dim ChNum,ChartNM,ChartStr" + vbCrLf
            script += "   ChartStr = Space(0)" + vbCrLf
            script += "   For ChNum = 0 To ArrayNum" + vbCrLf
            script += "      ChartNM=""chart""+Cstr(ChNum+1)" + vbCrLf
            script += "      ChartStr = ChartStr +  form1.item(ChartNM).Header.Text.Text + """" + Mid(CStr(ChartShow(ChNum)), 1, 1)" + vbCrLf
            script += "      If (ChNum < ArrayNum) Then" + vbCrLf
            script += "         ChartStr = ChartStr + """"" + vbCrLf
            script += "      End If" + vbCrLf
            script += "   Next" + vbCrLf
            script += "   AssemblyChartNameString = ChartStr" + vbCrLf
            script += "End Function" + vbCrLf + vbCrLf

            script += "Sub SplitScaleString(ByVal ScaleString)" + vbCrLf
            script += "   If (Len(ScaleString) > 0) Then" + vbCrLf
            script += "      Dim ChartStrArray,ArrayBound,ChartNum,ChartNM" + vbCrLf
            script += "      ChartStrArray = Split(ScaleString, """")" + vbCrLf
            script += "      ArrayBound = UBound(ChartStrArray)" + vbCrLf
            script += "      For ChartNum = 0 To ArrayBound" + vbCrLf
            script += "         If ChartShow(ChartNum) = True Then" + vbCrLf
            script += "            Dim ChartArray,LArray,RArray,ItemCnt" + vbCrLf
            script += "            ChartArray = Split(ChartStrArray(ChartNum), """")" + vbCrLf
            script += "            LArray = Split(ChartArray(0), """")" + vbCrLf
            script += "            RArray = Split(ChartArray(1), """")" + vbCrLf
            script += "            Ymax(ChartNum) = CSng(LArray(0))" + vbCrLf
            script += "            Ymin(ChartNum) = CSng(LArray(1))" + vbCrLf
            script += "            Yinc(ChartNum) = CSng(LArray(2))" + vbCrLf
            script += "            Ytick(ChartNum) = CSng(LArray(3))" + vbCrLf
            script += "            ChartNM=""chart""+Cstr(ChartNum+1)" + vbCrLf
            script += "            If (form1.item(ChartNM).Axis.Right.Visible=True) Then" + vbCrLf
            script += "               YRmax(ChartNum) = CSng(RArray(0))" + vbCrLf
            script += "               YRmin(ChartNum) = CSng(RArray(1))" + vbCrLf
            script += "               YRinc(ChartNum) = CSng(RArray(2))" + vbCrLf
            script += "               YRtick(ChartNum) = CSng(RArray(3))" + vbCrLf
            script += "            End If" + vbCrLf
            script += "         End If" + vbCrLf
            script += "      Next" + vbCrLf
            script += "      Call AutoScale(False)" + vbCrLf
            script += "   End If" + vbCrLf
            script += "End Sub" + vbCrLf + vbCrLf


            script += "Sub SetLegendToRightTop(ByRef ChartObj)" + vbCrLf
            'script += "   If ChartObj.Legend.Left = 1  Then" + vbCrLf
            script += "       Dim LegendWidth" + vbCrLf
            'script += "       Msgbox ""right="" & ChartObj.Legend.ShapeBounds.Right & "",left="" & ChartObj.Legend.ShapeBounds.Left" + vbCrLf
            script += "       LegendWidth = ChartObj.Legend.ShapeBounds.Right - ChartObj.Legend.ShapeBounds.Left" + vbCrLf
            'script += "       Msgbox ""clientwidth="" & ChartObj.ClientWidth & "",legendwidth="" & LegendWidth" + vbCrLf
            script += "       ChartObj.Legend.Left =  ChartObj.ClientWidth - LegendWidth" + vbCrLf
            'script += "       ChartObj.Legend.Left =  400" + vbCrLf
            'script += "       Msgbox ""ChartObj.Legend.Left ="" & ChartObj.Legend.Left" + vbCrLf
            'script += "   End If" + vbCrLf
            script += "End Sub" + vbCrLf + vbCrLf

            Return script
        End Function

        Public Shared Sub OnLineCoilChk(ByVal _Page As System.Web.UI.Page, ByVal NowPdate As String, ByVal NowPid As String)
            Dim JsString As String = ""
            JsString += "setInterval(""TM_onTick()"",5000);" + vbCrLf
            JsString += "function TM_onTick() {" + vbCrLf
            JsString += "   var pdate;" + vbCrLf
            JsString += "   var pid;" + vbCrLf
            JsString += "   var WebIP;" + vbCrLf
            JsString += "   WebIP = """ + _Page.Request.ServerVariables.Item("HTTP_HOST") + """" + vbCrLf
            JsString += "   docSubmit = new ActiveXObject(""MSXML2.DOMDocument"");" + vbCrLf
            JsString += "   docSubmit.async = false;" + vbCrLf
            JsString += "   docSubmit.load(""http://""+WebIP+""/hsm1spc/xml/NewCoil.xml"");" + vbCrLf
            JsString += "   pdate=docSubmit.documentElement.getElementsByTagName('PDate');" + vbCrLf
            JsString += "   pid=docSubmit.documentElement.getElementsByTagName('PID');" + vbCrLf
            'JsString += " alert(pid(0).text.length);" + vbCrLf
            'JsString += " alert(pdate(0).text ==" + NowPdate.Trim + ");" + vbCrLf
            JsString += "   if (pdate(0).text != " + NowPdate.Trim + " || pid(0).text !=" + NowPid.Trim + ")" + vbCrLf
            JsString += "      Form1.submit();" + vbCrLf
            JsString += "}" + vbCrLf
            RegisterJSScript(_Page, "ChkNewCoil", JsString)
        End Sub

        ''' <summary>
        ''' UVBScriptX
        ''' </summary>
        ''' <param name="_Page"></param>
        ''' <param name="key"></param>
        ''' <param name="VBString"></param>
        ''' <remarks></remarks>
        Public Shared Sub RegisterVBScript(ByVal _Page As System.Web.UI.Page, ByVal key As String, ByVal VBString As String)
            Dim scriptString As String = vbCrLf + "<script type=""text/vbscript"">" + vbCrLf
            scriptString += "<!--" + vbCrLf
            scriptString += VBString + vbCrLf
            scriptString += "'-->" + vbCrLf
            scriptString += "</script>" + vbCrLf
            If (Not _Page.ClientScript.IsStartupScriptRegistered(key)) Then
                '_Page.ClientScript.RegisterStartupScript(_Page.GetType, key, scriptString)
                ScriptManager.RegisterStartupScript(_Page, _Page.GetType, key, scriptString, False)
            End If
        End Sub

        ''' <summary>
        ''' UJSScriptX
        ''' </summary>
        ''' <param name="_Page"></param>
        ''' <param name="key"></param>
        ''' <param name="JSString"></param>
        ''' <remarks></remarks>
        Public Shared Sub RegisterJSScript(ByVal _Page As System.Web.UI.Page, ByVal key As String, ByVal JSString As String)
            Dim scriptString As String = vbCrLf + "<script type=""text/javascript"">" + vbCrLf
            scriptString += JSString + vbCrLf
            scriptString += "</script>" + vbCrLf
            If (Not _Page.ClientScript.IsStartupScriptRegistered(key)) Then
                '_Page.ClientScript.RegisterStartupScript(_Page.GetType, key, scriptString)
                ScriptManager.RegisterStartupScript(_Page, _Page.GetType, key, scriptString, False)
            End If
        End Sub

    End Class
End Namespace


m name="_page"></param>
        ''' <param name="WinChart"></param>
        ''' <param name="ChartName"></param>
        ''' <param name="ChartShow"></param>
        ''' <param name="XFormat"></param>
        ''' <param name="YFormat"></param>
        ''' <param name="RegisterScript"></param>
        ''' <param name="SaveFile"></param>
        ''' <param name="OnLine"></param>
        ''' <param name="Beep"></param>
        ''' <param name="mPdate"></param>
        ''' <param name="mPid"></param>
        ''' <remarks></remarks>
        Public Shared Sub ChartToClient(ByVal _page As BaseForm, ByVal WinChart As TeeChart.TChart(), ByVal ChartName As String(), ByVal ChartShow As Boolean(), ByVal XFormat As Single, ByVal YFormat As Single, Optional ByVal RegisterScript As Boolean = True, Optional ByVal SaveFile As Boolean = True, Optional ByVal OnLine As Boolean = False, Optional ByVal Beep As Boolean = False, Optional ByVal mPdate As String = "", Optional ByVal mPid As String = "")
            Dim cnt As Integer
            Dim ChartCount As Integer = WinChart.Length
            Dim TempFileName As String
            Dim StrJSScript As String
            SetChartStatus(_page, WinChart)
            For cnt = 0 To ChartCount - 1
                If ChartShow(cnt) Then
                    If SaveFile Then
                        SetTooLLineLimit(WinChart(cnt))
                        SetCursorSeries(WinChart(cnt))
                    End If
                    TempFileName = _page.Session("ChartTmpFile" + (cnt + 1).ToString)
                    If TempFileName Is Nothing Then
                        Dim today As Date = Now
                        Dim strDay As String = today.Year.ToString + Format(today.Month, "00") + Format(today.Day, "00")
                        TempFileName = strDay + _page.Server.CreateObject("Scripting.FileSystemObject").GetTempName
                    End If
                    If SaveFile Then
                        WinChart(cnt).Export.asNative.SaveToFile(_page.Request.PhysicalApplicationPath + "ChartTemp\" + TempFileName, True)
                    End If
                    _page.Session("ChartTmpFile" + (cnt + 1).ToString) = TempFileName
                Else
                    _page.Session("ChartTmpFile" + (cnt + 1).ToString) = Nothing
                End If
            Next
            RegisterVBScript(_page, "TeeChartEventHandler", CreateChartEvent(_page, RegisterScript, ChartName, ChartShow, XFormat, YFormat, OnLine, Beep))

            StrJSScript = "var oldWindowLoad = window.onload || function(){};" + vbCrLf
            StrJSScript += "window.onload = function(){" + vbCrLf
            StrJSScript += "oldWindowLoad();" + vbCrLf
            If RegisterScript Then
                SetGridCheckBox(_page, WinChart(0).Axis.Left.GridPen.Visible, StrJSScript)
            End If

            SetChartHeight(_page, WinChart, ChartName, StrJSScript)
            SetLegendLeftPosition(_page, WinChart, ChartName, StrJSScript)
            StrJSScript += "};"
            RegisterJSScript(_page, "ExtraScript", StrJSScript)
        End Sub

        Public Shared Sub SetLegendLeftPosition(ByVal paramPage As Page, ByVal paramTChart As TeeChart.TChart(), ByVal paramChartName As String(), ByRef paramScript As String)
            For i As Int16 = 0 To paramTChart.Length - 1
                If paramTChart(i).Legend.CustomPosition = True AndAlso paramTChart(i).Legend.Left = 0 Then
                    paramScript += "document.all(""" + paramChartName(i) + """).Legend.Left=" + paramTChart(i).Width.ToString + "-" + CalcLegendWidth(paramTChart(i), paramTChart(i).Width).ToString + ";" + vbCrLf
                End If
            Next
        End Sub

        ''' <summary>
        ''' ഫColor
        ''' </summary>
        ''' <param name="_color"></param>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Shared Function VBColor(ByVal _color As Color) As System.UInt32
            'ഫColor->UInt32(TeeChart Active Color Property)
            VBColor = System.UInt32.Parse(RGB(CType(_color.R, Byte), CType(_color.G, Byte), CType(_color.B, Byte)))
        End Function

        Private Shared Sub SetGridCheckBox(ByVal paramPage As BaseForm, ByVal paramShowGrid As Boolean, ByRef paramScript As String)
            Dim ChkID As String = "UCTeeChartToolBar" & paramPage.PageID & "_Checkbox3"
            paramScript += "     document.getElementById('" & ChkID & "').checked = " & paramShowGrid.ToString.ToLower & vbCrLf
        End Sub

        ''' <summary>
        ''' oTempChartɮצW
        ''' </summary>
        ''' <param name="_page"></param>
        ''' <param name="chartNum"></param>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Private Shared Function GetChartTmpFile(ByVal _page As System.Web.UI.Page, ByVal chartNum As Integer) As String
            GetChartTmpFile = _page.Session("ChartTmpFile" + (chartNum + 1).ToString)
        End Function

        ''' <summary>
        ''' beݲChartƥ
        ''' </summary>
        ''' <param name="_page"></param>
        ''' <param name="RegisterScript"></param>
        ''' <param name="ChartName"></param>
        ''' <param name="ChartShow"></param>
        ''' <param name="XFormat"></param>
        ''' <param name="YFormat"></param>
        ''' <param name="OnLine"></param>
        ''' <param name="Beep"></param>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Private Shared Function CreateChartEvent(ByVal _page As BaseForm, ByVal RegisterScript As Boolean, ByVal ChartName As String(), ByVal ChartShow As Boolean(), ByVal XFormat As Single, ByVal YFormat As Single, Optional ByVal OnLine As Boolean = False, Optional ByVal Beep As Boolean = False) As String
            Dim cnt As Integer
            Dim FormName As String = ""
            Dim ChartNo As String
            Dim ScripString As String = ""
            Dim _fcontrol, _control, _divResultArea As System.Web.UI.Control
            Dim KeepStatus As Boolean = False
            Dim ChkRealtimeID As String = "UCRealtimeSwitch" + _page.PageID + "_ChkBoxRealtime"
            If RegisterScript Then
                For Each _fcontrol In _page.Controls
                    If _fcontrol.GetType.ToString.Trim = "System.Web.UI.HtmlControls.HtmlForm" Then
                        FormName = _fcontrol.ID
                        For cnt = 0 To ChartShow.Length - 1
                            If ChartShow(cnt) Then
                                ChartNo = "chart" + (cnt + 1).ToString
                                ScripString += "Sub " + ChartNo + "_OnCursorToolChange(Tool , X , Y , XVal ,  YVal , SeriesIndex ,ValueIndex )" + vbCrLf
                                ScripString += "    Call CursorChange(document.all(""" + ChartNo + """), X, Y, XVal, YVal, SeriesIndex, ValueIndex)" + vbCrLf
                                ScripString += "End Sub" + vbCrLf + vbCrLf

                                ScripString += "Sub " + ChartNo + "_OnClick()" + vbCrLf
                                ScripString += "    Call LegendClick(document.all(""" + ChartNo + """))" + vbCrLf
                                ScripString += "End Sub" + vbCrLf + vbCrLf
                            End If
                        Next

                        _divResultArea = _fcontrol.FindControl("DivResultArea")
                        If _divResultArea IsNot Nothing Then
                            _fcontrol = _divResultArea
                        End If

                        For Each _control In _fcontrol.Controls
                            If _control.GetType.ToString.Trim = "ASP.usercontrols_ucteecharttoolbar_ascx" Then
                                For Each _subcontrol As System.Web.UI.Control In _control.Controls
                                    Select Case _subcontrol.GetType.ToString.Trim
                                        Case "System.Web.UI.HtmlControls.HtmlInputCheckBox"
                                            If CType(_subcontrol, HtmlInputCheckBox).Attributes.Item("title").Trim.Length > 0 Then
                                                ScripString += "Sub " + _subcontrol.ClientID.Trim + "_onclick" + vbCrLf
                                                ScripString += "    Call ChkBoxFunction(document.all(""" + _subcontrol.ClientID.Trim + """))" + vbCrLf
                                                ScripString += "End Sub" + vbCrLf + vbCrLf
                                            End If
                                        Case "System.Web.UI.HtmlControls.HtmlInputButton"
                                            If CType(_subcontrol, HtmlInputButton).Attributes.Item("title").Trim.Length > 0 Then
                                                ScripString += "Sub " + _subcontrol.ClientID.Trim + "_onclick" + vbCrLf
                                                ScripString += "    Dim ChkRealtime" + vbCrLf
                                    